// * This code is licensed under:
// * JRunMC License, Version 1.0
// * - for license details see http://runmc.sourceforge.net/License.txt
// *
// * Copyright (c) 2005 by S.Chekanov (chekanov@mail.desy.de). 
// * All rights reserved.
package JRunMC.ui;

import JRunMC.util.*;

// Main-Class: JRunMC main class 
import java.io.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.event.*;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.border.*;
import javax.swing.filechooser.*;
import javax.swing.text.*;

/** 
 *  <UL>
 *    <LI>
 *       RunMC v4.0
 *    <LI>
 *  </UL>
 *   S.Chekanov
 */

public class JRunMC extends JFrame {
  

  public static final long serialVersionUID =  1000;
  
  private javax.swing.JSplitPane jSplitPane1;
  private javax.swing.JTabbedPane jTPane1;
  private TabTop T0; // menu bar
  private Tab1 T1;
  private Tab2 T2;
  private Tab3 T3;
  private Tab4 T4;
  private Tab5 T5;
  private Tab6 T6;
  private TabBottom T7;
  private JFileChooser fc;
  public  EditorHisto histo;
  // stor previus settings 

  private static String ShowInitStateTMP="";
  private static String ShowCanvasTMP="";
  private static String ShowFSTMP="";
  private static String ShowFoutTMP="";
  private static String ShowHistoNTMP=""; 
  private static String ShowStatusTMP="";
  private static int  StyleTMP=0;

  // timer to check pipe files
  private int delay1 = 0;   // delay for 5 sec.
  private int period1 = 2000;  // repeat every sec.
  private Timer timer0; // main timer to update summary - always active 
  private Timer timer1; // to run
  private Timer timer2; // for RMC

  static public boolean RMCloading = false;
 
  static public String pipe_stop;
  static public String pipe_event;
  static public String pipe_file;
  
  

   public JRunMC(String file) {


        System.out.println( "Input:"+file );

        try {
        UIManager.setLookAndFeel(UIManager.getCrossPlatformLookAndFeelClassName());
        }
         catch (Exception e) { System.out.println( "Cannot load Look&Feel" );
                       e.printStackTrace();  }


/*
         try {
        //  UIManager.setLookAndFeel("com.birosoft.liquid.LiquidLookAndFeel");
        //   UIManager.setLookAndFeel(UIManager.getCrossPlatformLookAndFeelClassName());
          UIManager.setLookAndFeel(SetEnv.kunststoffClassName);

         }
         catch (Exception e) { System.out.println( "Cannot load Look&Feel" );
                       e.printStackTrace();  }

*/



// Java naitive
    try {
//      UIManager.setLookAndFeel(UIManager.getCrossPlatformLookAndFeelClassName());
      // change to RunMC defaults
      Font fnt = new Font("Lucida Sans", Font.BOLD, 14);
      Font fnt16 = new Font("Lucida Sans", Font.BOLD, 16);
      Font fnt12 = new Font("Lucida Sans", Font.BOLD, 12);
      UIManager.put("MenuBar.font",fnt16);
      UIManager.put("MenuItem.font",fnt16);
      UIManager.put("Button.font", fnt);
      UIManager.put("List.font", fnt);
      UIManager.put("ToggleButton.font",fnt);
      UIManager.put("Panel.font", fnt);
      UIManager.put("ComboBox.font", fnt);
      UIManager.put("RadioButtonMenuItem.font", fnt);
      UIManager.put("PopupMenu.font", fnt);
      UIManager.put("MenuItem.font", fnt);
      UIManager.put("OptionPane.font", fnt);
      UIManager.put("ScrollPane.font", fnt);
      UIManager.put("RadioButton.font", fnt);
      UIManager.put("TabbedPane.font", fnt);
      UIManager.put("Table.font", fnt);
      UIManager.put("TableHeader.font",fnt12);
      UIManager.put("TextField.font", fnt);
      UIManager.put("TextPane.font",fnt);
      UIManager.put("TextArea.font", fnt);
      UIManager.put("ToolBar.font", fnt);
      UIManager.put("ToolTip.font", fnt12);
      UIManager.put("Dialog.font", fnt);
      UIManager.put("CheckBox.font", fnt);
      UIManager.put("Menu.font", fnt);

    // UIManager.put("Button.background", new Color(200, 200, 220));
    //  UIManager.put("Panel.background", new Color(212, 208, 200));
    //  UIManager.put("Label.background", new Color(210, 210, 190));
    //  UIManager.put("OptionPane.background", new Color(210, 210, 190));
    //  UIManager.put("TabbedPane.background", new Color(201, 201, 201));
    //  UIManager.put("ToggleButton.background",new Color(201, 191, 227));

    }
    catch(Exception e) {
      e.printStackTrace();
    }

    setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
    setTitle( ResourceLoader.getDisplay("ui.title") );


// initialize panels 
    T0 = new TabTop();
    T1 = new Tab1();
// start monitoring
    T1.StartTimer();

    T2 = new Tab2();
    T3 = new Tab3();
    T4 = new Tab4();
    T5 = new Tab5();
    T6 = new Tab6();
    T7 = new TabBottom();
    histo= new EditorHisto();
    // define timer for updatting GUI  
     timer0 = new Timer(500, taskUPDATE);
     timer0.setRepeats(true); 
     timer0.start();

 
   // define timer for pipe files
     timer1 = new Timer(period1, taskRUN);
    // timer1.setInitialDelay(delay1); 
   
     // timer for RPC loading
     timer2 = new Timer(period1, taskRMC);
    // timer2.setInitialDelay(delay1); 
  
// open MC file, if there is need to open it
   if (file.equals("none")) {
//   System.out.println("no input");  
   } else { 

    if (file.length()>2) {
       try { SetIni.FileReadMC(file);
               } catch (Exception e) {
         System.out.println("Error in file oppening "+file);}
         SetAll();  // set all
         histo.LoadHistograms(); // set histograms
         T7.setPan();  // show summary  
   }
   }



 
     Container content = getContentPane();
     setJMenuBar(T0);


        jSplitPane1 = new JSplitPane();
        jSplitPane1.setOneTouchExpandable(true);
        jSplitPane1.setDividerLocation(210);
        jTPane1 = new JTabbedPane();



// show histogram editor
     T4.bhisto.addActionListener(new java.awt.event.ActionListener() {
     public void actionPerformed(java.awt.event.ActionEvent evt1) {
            ShowMess("Start histogram editor");
            histo.SetVariables();   // set variables
            histo.removeAll();      // remove histograms
            histo.LoadHistograms(); // set histograms
            histo.setVisible(true);
            // histo.show();
            // System.out.print("Something is wrong");
             } } );


        
   T2.MClist.addListSelectionListener(new ValueReporter1());
   T2.NTlist.addListSelectionListener(new ValueReporter2()); 

             
// show summary 
     T7.setPan();
 // start run 
     T7.brun.addActionListener(new java.awt.event.ActionListener() {
     public void actionPerformed(java.awt.event.ActionEvent evt) {

       boolean RunIt=true;  


       if (RMCloading == true  &&  RunIt == true && SetEnv.RunAllow == true) {
        JOptionPane dialog = new JOptionPane();
             dialog.showMessageDialog(dialog,
             "RMC file is not ready yet",
             "Warning", JOptionPane.WARNING_MESSAGE);
        RunIt=false;
        } 

// now check for errors
       String rError=Utility.runmcError();
       if (rError.length()>2) {
       JOptionPane dialog = new JOptionPane();
             dialog.showMessageDialog(dialog,
              rError,
             "Warning", JOptionPane.WARNING_MESSAGE);
        RunIt=false;
        }


      if (SetEnv.ReadMCdone == false && RunIt == true && SetEnv.RunAllow == true) {   
       JOptionPane dialog1 = new JOptionPane();
       int ask=dialog1.showConfirmDialog(dialog1,
       "You did not load \"<project>.mc\" file. \n This could lead to inconsistent initialization. \n Continue anyway?",
       "Question", JOptionPane.YES_NO_OPTION,
       JOptionPane.QUESTION_MESSAGE, null );
       if (ask == JOptionPane.YES_OPTION) SetEnv.RunAllow=true;
       if (ask == JOptionPane.NO_OPTION) {
                 RunIt=false;
                 ShowMess("Run has been terminated");
                };
      }


       // control card 
     if (SetIni.MCtype>0 &&   RunIt== true && SetEnv.RunAllow == true) { 
       String cur_card= SetIni.card[SetIni.MCtype];
       File filecard = new File(cur_card);
       // check control card
      if ( filecard.exists() ) {
       JOptionPane dialog1 = new JOptionPane();
       int ask=dialog1.showConfirmDialog(dialog1, "Use control card "+cur_card+" ?",
       "Question", JOptionPane.YES_NO_OPTION,
       JOptionPane.QUESTION_MESSAGE, null );
       if (ask == JOptionPane.YES_OPTION) RunIt=true;
       if (ask == JOptionPane.NO_OPTION) {
                 RunIt=false;
                 ShowMess("Run has been terminated");
                };
      } else { // if card does not exist
      JOptionPane dialog1 = new JOptionPane();
      int ask=dialog1.showConfirmDialog(dialog1,
      "No control card "+cur_card+" is found. Continue?" ,
      "Question", JOptionPane.YES_NO_OPTION,
      JOptionPane.QUESTION_MESSAGE, null );
      if (ask == JOptionPane.YES_OPTION) RunIt=true;
      if (ask == JOptionPane.NO_OPTION){
               RunIt=false;
               ShowMess("Run has been terminated");
               };
      } 
      } // end (SetIni.MCtype

//     System.out.println(RunIt);
//     System.out.println(SetEnv.RunAllow);
 
     if (RunIt == true && SetEnv.RunAllow == true)  { 
                                       RunIt  = false;
                                       StartRunning(); };

 
      if (RunIt == true && SetEnv.RunAllow == false ) {
                                     RunIt  = false;
                                     StopRunning(); };
 

          
        
     }  }); 


    jSplitPane1.setOrientation(javax.swing.JSplitPane.VERTICAL_SPLIT);
    jSplitPane1.setLeftComponent(jTPane1);
    content.add(jSplitPane1, java.awt.BorderLayout.CENTER);

    jTPane1.addTab(ResourceLoader.getDisplay("tab.welcome"), T1);
    jTPane1.addTab(ResourceLoader.getDisplay("tab.mc"),T2);
    jTPane1.addTab(ResourceLoader.getDisplay("tab.settings"),T3);
    jTPane1.addTab(ResourceLoader.getDisplay("tab.output"), T4);
    jTPane1.addTab(ResourceLoader.getDisplay("tab.options"),T5);
    jTPane1.addTab(ResourceLoader.getDisplay("tab.control"),T6);

     // Register a change listener
     jTPane1.addChangeListener(new ChangeListener() {
        public void stateChanged(ChangeEvent evt) {
            JTabbedPane pane = (JTabbedPane)evt.getSource();
            // Get current tab
            SetEnv.TabActive = pane.getSelectedIndex();

            // start checking if first tab is active
            if (SetEnv.TabActive == 0) {
             T1.StartTimer();
            } else {
             T1.StopTimer();
            } 

    } } );


    jSplitPane1.setRightComponent(T7);

    pack();
    setVisible(true);

  }


    public class ValueReporter1 implements ListSelectionListener {
      public void valueChanged(ListSelectionEvent event) {
      if (!event.getValueIsAdjusting())  {
        if (!T2.MClist.isSelectionEmpty() ) {
        T7.MCField.setText(T2.MClist.getSelectedValue().toString());
        SetIni.MCtype = T2.MClist.getSelectedIndex()+1; 
        T3.NTpanel.setVisible(false);
        T3.SETTINGpanel.setVisible(true);   
        // clear ntuple selection
        T2.NTlist.clearSelection(); 
        T2.NTlist.repaint();                
        // show or not show ThePeG
        T3.ThePeg.setVisible(false);
        // System.out.println(SetIni.MCtype);
        if (SetIni.MCtype == 9) {
             T3.ThePeg.setVisible(true); 
             // show worning 
             JOptionPane dialog = new JOptionPane();
             dialog.showMessageDialog(dialog,
             "ThePEG is not implemented, this is a demo version of future development by Leif Lonnblad \n"+
             "Check \"ThePEG settings\" on \"MC settings\" panel",
             "Warning", JOptionPane.WARNING_MESSAGE);  
       }

        T3.ThePeg.repaint();
        }
        }   } }


    
    
    public class ValueReporter2 implements ListSelectionListener {
      public void valueChanged(ListSelectionEvent event) {
      if (!event.getValueIsAdjusting())  {
       if (!T2.NTlist.isSelectionEmpty() ) {
        // clear MC selection
        T2.MClist.clearSelection(); 
        T2.MClist.repaint();    
        // show pannel with settings
        T3.NTpanel.setVisible(true);
        T3.SETTINGpanel.setVisible(false);
        T7.MCField.setText(T2.NTlist.getSelectedValue().toString());
        int nn=0;
        if (T2.NTlist.getSelectedIndex() == 0) nn=-1;
        if (T2.NTlist.getSelectedIndex() == 1) nn=-2;
        if (T2.NTlist.getSelectedIndex() == 2) nn=-3;
        SetIni.MCtype =nn; 
        }
        }  } }      
    
    
    // for file chooser
     class FilterMC extends javax.swing.filechooser.FileFilter {
        public boolean accept(File file) {
            String filename = file.getName();
            return filename.endsWith(".mc"); }
            public String getDescription() {
            return "*.mc"; }  }

 // for file chooser
      class FilterRMC extends javax.swing.filechooser.FileFilter {
        public boolean accept(File file) {
            String filename = file.getName();
            return filename.endsWith(".rmc");  }
        public String getDescription() {
            return "*.rmc"; }  }
    
   
      
    
// set all instances
     public void SetAll(){

        // set pannel   
        T2.setPan();
        T3.setPan(); 
        T4.setPan();
        T5.setPan();
        T6.setPan();
        T7.setPan();
        ShowMess(SetIni.MOutput+".mc  file was loaded");

// set NT panel 
       if (SetIni.MCtype>=0) {
             T3.NTpanel.setVisible(false);
             T3.SETTINGpanel.setVisible(true);
        }
       if (SetIni.MCtype<0) {
             T3.NTpanel.setVisible(true);
             T3.SETTINGpanel.setVisible(false);
        }

    
   } // end set all  
     



  // timer task   
  ActionListener taskRUN = new ActionListener() {
            boolean alreadyDisposed = false;
            public void actionPerformed(ActionEvent e) {
          
          // read pipe file
          int val=0;    
          try {
          FileReader inF = new FileReader(pipe_event);
          BufferedReader br = new BufferedReader(inF);
          String s;
          while (( s=br.readLine())!= null) { 
          String[] words = s.split (" ");  
          words[0]=words[0].trim();
              ShowMess("RunMC is running..  "+words[0]+" events processed");
          val=Utility.GetInt(words[0]); }
          inF.close(); }
          catch (IOException et) {System.out.println("Error in reading pipes");}
           
          // show number of events in %
          double x=100.0*(  (double)val / (double)SetIni.Nevents ); 
           int vax = (int)x;     
          // System.out.println(SetIni.Nevents);
          // System.out.println(val);      
          // System.out.println(vax);
          // show progress bar
          T7.pb1.setValue(vax);                  
          // reset bottom 

          // check errorfile: 
          File fileerr = new File(SetIni.MOutput+".err"); 
          long length = fileerr.length();
// show error
          if (length>2) {

                   StopRunning(); 
                   T7.statusBar.setText("Error:  check "+SetIni.MOutput+".err ");
                   // show dialog 
                  JOptionPane dialog = new JOptionPane();
                  dialog.showMessageDialog(dialog, 
                   "Error while generating events. Check "+SetIni.MOutput+".err",
                  "Error", JOptionPane.ERROR_MESSAGE ); 
           } 

          if (val >= SetIni.Nevents)  {

          StopRunning();
          ShowMess("Current run was finished");
          // show the results (if the file exitst!) 
           File f1 = new File (SetEnv.RUNDIR+
                     File.separator+"proj"+File.separator+".runmc.out");  
           if (f1.exists()) new ResultDialog(f1); 

          }    
                   
          }   };
   
  
  
  
     // timer task: load RMC   
      ActionListener taskRMC = new ActionListener() {
            boolean alreadyDisposed = false;
            public void actionPerformed(ActionEvent ermc) {
     
          final int NumMC=9; // number of MC models 
          int val=0; 
          int iu=0;
          int cntfile=0;

          String path=SetEnv.RUNDIR;
          if (SetEnv.OSsys.equals("windows") ) path=SetEnv.RUNDIRwin32;


          String sss=path+File.separator+"main"+File.separator+
                     "tmp"+File.separator+"checkmake.tmp";


          try {

          FileReader inF = new FileReader(sss);
          BufferedReader br = new BufferedReader(inF);
          String s;
          while (( s=br.readLine())!= null) { 
          val=Utility.GetInt(s); iu++;}
          br.close(); inF.close(); }
          catch (IOException et) {System.out.println("Error in reading RMC pipes");} 
          // System.out.println("OK "+val+" "+iu);
          cntfile=val;


          if ( cntfile < NumMC) {
          int vax=(int)(100.0*(double)cntfile/(double)NumMC); 
          // show progress bar
          T7.pb1.setValue(vax);         
          RMCloading=true; // running 
          ShowMess("Wait .. a new RMC project is compiling: "+Integer.toString(vax)+"%");
          }



          // all done -- do now
           if ( cntfile >= NumMC) {

          // get MC file  
          String name=RMCaction.getName();
          if (name.equals("none")) {
          String rError="cannot find <project>.mc file!";
          JOptionPane dialogError = new JOptionPane();
          dialogError.showMessageDialog(dialogError,rError,"Error",JOptionPane.ERROR_MESSAGE);
          } 
             // get full path 
             String sss1=path+File.separator+"proj"+File.separator+name+".mc";
             
             try { SetIni.FileReadMC( sss1 );
             } catch (Exception e1) {   
             System.out.println("JRunMC: Error in file openning:\n"+sss1); }
             SetAll();              // update GUI
             histo.removeAll();     // remove all histograms from previous RMC 
             histo.SetVariables();  // set variables
             histo.LoadHistograms(); // set histograms

             cntfile=0;
             val=0; 
             timer2.stop();
             T7.setPan(); // summary   
             T7.pb1.setValue(0);
             RMCloading=false; // nor running             
             ShowMess("RMC file was loaded");
             T1.FillMCtable(); // fill table with available MC

             EditorInfo ed= new  EditorInfo(); ed.ShowHTML();

           }
           }; };



// timer task: update GUI 
      ActionListener taskUPDATE = new ActionListener() {
            boolean alreadyDisposed = false;
            public void actionPerformed(ActionEvent ermc) {

 
             // initial state;
             if (SetEnv.Style != StyleTMP) {
                ShowMess("GUI style has changed");
               StyleTMP=SetEnv.Style;

                if (SetEnv.Style == 0) {
                try {
                UIManager.setLookAndFeel(UIManager.getCrossPlatformLookAndFeelClassName());
       //       UIManager.setLookAndFeel(UIManager.getCrossPlatformLookAndFeelClassName()); 
                SwingUtilities.updateComponentTreeUI(JRunMC.this);
                JRunMC.this.pack();
                }
                catch (Exception exc) {
                  ShowMess("Could not load LookAndFeel");
                }
                }


                if (SetEnv.Style == 1) {  
                try {
                UIManager.setLookAndFeel(SetEnv.metalClassName);
                SwingUtilities.updateComponentTreeUI(JRunMC.this);
                JRunMC.this.pack();
                }
                catch (Exception exc) {
                   ShowMess("Could not load LookAndFeel"); 
                }
                }
 
                if (SetEnv.Style == 2) {
                try {
                UIManager.setLookAndFeel(SetEnv.motifClassName);
                SwingUtilities.updateComponentTreeUI(JRunMC.this);
                JRunMC.this.pack();
                }
                catch (Exception exc) {
                  ShowMess("Could not load LookAndFeel");
                }
                }

                if (SetEnv.Style == 3) {
                try {
                UIManager.setLookAndFeel(SetEnv.windowsClassName);  
                SwingUtilities.updateComponentTreeUI(JRunMC.this);
                JRunMC.this.pack();
                }
                catch (Exception exc) {
                  ShowMess("Could not load LookAndFeel");
                }
                }

                if (SetEnv.Style == 4) {
                try {
                UIManager.setLookAndFeel(SetEnv. liquidClassName);
                SwingUtilities.updateComponentTreeUI(JRunMC.this);
                JRunMC.this.pack();
                }
                catch (Exception exc) {
                ShowMess("Could not load LookAndFeel");
                }
                }

                if (SetEnv.Style == 5) {
                try {
                  UIManager.setLookAndFeel(SetEnv.kunststoffClassName);
             //   UIManager.setLookAndFeel(SetEnv. liquidClassName);
                SwingUtilities.updateComponentTreeUI(JRunMC.this);
                JRunMC.this.pack();
                }
                catch (Exception exc) {
                  ShowMess("Could not load LookAndFeel");
                }
                }


             }



  // initial state;
             if (!SetIni.ShowInitState.equals(ShowInitStateTMP)) {
               T7.iniState.setText(SetIni.ShowInitState);
               ShowInitStateTMP=SetIni.ShowInitState;
             }

// FS  state
            if (!SetIni.ShowFS.equals(ShowFSTMP)) {
               T7.finState.setText(SetIni.ShowFS);
               ShowFSTMP=SetIni.ShowFS;
             }

            // canvas state
            if (!SetIni.ShowCanvas.equals(ShowCanvasTMP)) {
               T7.canvasOut.setText(SetIni.ShowCanvas);
               ShowCanvasTMP=SetIni.ShowCanvas;
             }

             // file output
            if (!SetIni.ShowFout.equals(ShowFoutTMP)) {
               ShowFileOut(SetIni.ShowFout);
               ShowFoutTMP=SetIni.ShowFout;
             }

          // file output
            if (!SetIni.ShowHistoN.equals(ShowHistoNTMP)) {
               T7.outHisto.setText(SetIni.ShowHistoN);
               ShowHistoNTMP=SetIni.ShowHistoN;
             }



         }; };


// show message on the GUI (bottom)
public void ShowMess(String mess, Color col) {
     T7.statusBar.setForeground(col); 
     T7.statusBar.setText("Last action: "+mess);
 } // end 

// show initial state 
public void ShowMess(String mess) {
     T7.statusBar.setForeground(Color.black);
     T7.statusBar.setText("Last action: "+mess);
 } // e

// show message on the GUI with the default action 
public void ShowInitialState(String mess) {
     T7.iniState.setText(mess); 
 } // end


// show message on the GUI with the default action
public void ShowFinalState(String mess) {
    T7.finState.setText(mess);
 } //


public void ShowCanvas(String mess) {
   T7.canvasOut.setText(mess);
}

public void ShowFileOut(String mess) {
   T7.outFiles.setText(mess);
}


public void OpenMCfile() { 
 //Create a file chooser

               String path=SetEnv.RUNDIR;
               if (SetEnv.OSsys.equals("windows") ) path=SetEnv.RUNDIRwin32;

               fc = new JFileChooser(path+File.separator+"proj");
               fc.addChoosableFileFilter(new FilterMC());
               int returnVal = fc.showOpenDialog(JRunMC.this);
               if (returnVal == JFileChooser.APPROVE_OPTION) {
               File file = fc.getSelectedFile();
               String sname=fc.getSelectedFile().getAbsolutePath();
               String sn=file.getName();
               try {SetIni.FileReadMC(sname);
                    ShowMess(sn+" file is loaded");
               } catch (Exception e) {
                  System.out.println("Error in file openning");
                  // show error
                  JOptionPane dialog = new JOptionPane();
                  dialog.showMessageDialog(dialog, "Cannot read "+sn,
                  "Error", JOptionPane.ERROR_MESSAGE ); }
               SetAll();               // set all GUI components
               histo.removeAll();      // remove first histograms
               histo.LoadHistograms(); // set histograms
               T7.setPan();
             };  

} // end open MC file 



public void OpenRMCfile( String  s1 ) {


   String path=SetEnv.RUNDIR;
   if (SetEnv.OSsys.equals("windows") ) path=SetEnv.RUNDIRwin32;


//    System.out.println("Load "+s1);

    if (RMCloading) { 

    JOptionPane dialog = new JOptionPane();
             dialog.showMessageDialog(dialog,
             "Cannot load. Please wait!", "Warning", JOptionPane.WARNING_MESSAGE);  
    }
 

    if (!RMCloading) { 


    
    String ss=path+File.separator+"archive"+File.separator+s1;
    File file = new File (ss);

   // reset file to zero
   try {

   String sss=path+File.separator+"main"+
              File.separator+"tmp"+File.separator+"checkmake.tmp";
   FileOutputStream tmpc = new FileOutputStream( sss );
   PrintStream tmpcheck = new PrintStream(tmpc);
   tmpcheck.print("0"); tmpcheck.close();} catch (IOException e){
   System.out.println("RunMC tmp pipe error: "+e); }


             
 // get RMC file
                if(file.exists()) { 
                // System.out.println(sname);
                ShowMess(ss+" file is loading..");

                ShowMess("Wait! RMC project compiling..");
      
                 T7.pb1.setValue(0);
                 T7.pb1.setForeground(new Color(255, 173, 0));

                 // start timer
                timer2.start();
                new Thread1("Start loading RMC file ", s1);
                // load file  
                // RMCaction.load(ss);
                } 

  } // wait for RMC loading 

 } //  end of OpenRMCfile()




public void StartRunning() { 

   // set to 0 progress bar
     T7.pb1.setValue(0);

     pipe_file=Utility.GetPipe();

     String path=SetEnv.RUNDIR;
     if (SetEnv.OSsys.equals("windows") ) path=SetEnv.RUNDIRwin32;


     pipe_stop=path+File.separator+"pipes"+File.separator+pipe_file+".stop";
     pipe_event=path+File.separator+"pipes"+File.separator+pipe_file+".event";
     SetIni.PipeName=pipe_file;


// remove old MC file (read from start-up)
        String oldf=path+File.separator+"proj"+File.separator+SetIni.MOutputOld+".mc";
        File myFile = new File(oldf);
// remove prevous file to exclude a dublicate
        try {  myFile.delete();
        }
        catch (SecurityException e) {
//      System.out.println("Caught security exception"); 
        }

      // write new MC file
      try { SetIni.FileWriteMC(SetIni.MOutput+".mc");
      } catch (Exception e) {
      System.out.println("Something is wrong in making new MC file"); };

     // set pipe file
       try {FileOutputStream pipestop = new  FileOutputStream (pipe_stop);
       PrintStream pstop = new PrintStream(pipestop);
       SetIni.Stop=0; pstop.print("0"); pstop.close();} catch (IOException e){
       System.out.println("RunMC pipe error: "+e); }

       // create event pipe file
       try {FileOutputStream pipestop = new  FileOutputStream (pipe_event);
       PrintStream pstop = new PrintStream(pipestop);
       SetIni.Stop=0; pstop.print("0"); pstop.close();} catch (IOException e){
       System.out.println("RunMC pipe error: "+e); }

   // make link
     File ff1=new File(".runmc.in");
     boolean bff1=ff1.delete();
     File ff2=new File(SetIni.MOutput+".log");
     boolean bff2=ff2.delete();
     File ff3=new File(SetIni.MOutput+".err");
     boolean bff3=ff3.delete();
   //  if (bff1)  System.out.println("File .analmc.ln removed");
   //  if (bff2)  System.out.println("File "+SetIni.MOutput+".log removed");
   //  if (bff3)  System.out.println("File "+SetIni.MOutput+".err removed");


     Runtime r1=Runtime.getRuntime();
     Process p1=null;
     String sh = "bash"; String cop = "-c";
     String cmd1 = "ln -s "+SetIni.MOutput+".mc" +" .runmc.in";
     String[] exe1 = new String[] {sh, cop, cmd1};
     // make link
     try {p1=r1.exec(exe1);}
     catch (Exception e) {System.out.println("Error to make link");}

     sh = "bash"; cop = "-c";
     String cmd2 = "ln -s "+SetIni.MOutput+".log" +" .runmc.log";
     String[] exe11 = new String[] {sh, cop, cmd2};
     // make link
     try {p1=r1.exec(exe11);}
     catch (Exception e) {System.out.println("Error to make link to log file");}

 // run
     String[] exe2 = new String[] {sh, cop, Utility.runjob(SetIni.MCtype)};
     try {p1=r1.exec(exe2);}
     catch (Exception e) {System.out.println("Error to execute");}

    // define  stop
    T7.pb1.setForeground(new Color(120, 120, 255));
    T7.statusBar.setForeground(Color.red);
    SetIni.ShowStatus="RunMC is running..";
    SetEnv.RunAllow = false;
    T7.brun.setSelected(true);
    T7.brun.setToolTipText("To terminate this run, click here");
    T7.brun.setBackground( new Color(200, 255, 200)  );
    T7.brun.setText("Stop");

      // start timer
    timer1.start();

   } 





public void StopRunning() {

     // stop progress bar
    T7.pb1.setValue(0);

    // set 1 in pipes
    try {FileOutputStream pipestop = new  FileOutputStream (pipe_stop);
    PrintStream pstop = new PrintStream(pipestop);
    // System.out.println(Utility.GetPipe(1));
    SetIni.Stop=1;
    pstop.print("1"); pstop.close();} catch (IOException e){
    System.out.println("RunMC error: "+e); }
     
    // stop timer
    timer1.stop();

    SetEnv.RunAllow = true;
    T7.brun.setSelected(false);
    T7.brun.setToolTipText("To start a new run, click here");
    T7.brun.setBackground( new Color(230, 230, 240)  );
    T7.brun.setText("Run");



   }



// make HTML lins in thread ..
class Thread1 implements Runnable {

 public String ssLoadedFile=" ";
 
 Thread t;
 Thread1(String s1, String ss) {
       ssLoadedFile=ss;   
       t= new Thread (this,s1);
       t.start();
 }
   public void run() {
        // start loading
        RMCaction.load( ssLoadedFile );


   }
 } // end Thread1



     
}

