#!/bin/bash

# define here RunMC library directory
# you can set it to /usr/local if
# you want all users to use RunMC  
# RunMC directory will be $RUNMC_DIR/RunMC
RUNMC_DIR="/usr/local"


# ------------------- do not modify anything below ----------------
CURRENT_DIR=`pwd`

# get $RUNMC variable (assume current direcory)
LL=`expr length "$CURRENT_DIR"`
LL=`expr $LL-6`
RUNMC=${RUNMC:0:$LL}



# chech ROOT permiss
ROOT_UID=0         # Root has $UID 0.
# This script must be run as root.
if [ "$UID" -ne "$ROOT_UID" ]
then
  echo; echo "You must be root to run this script."; 
  exit 1; 
fi  

# installation directory
RUNMCDIR=$RUNMC_DIR"/RunMC"

echo " "
echo " "
echo "                --- RunMC Toolkit Installation  ---"
echo " "
echo " "


FCHECK=$RUNMC 
if [ -z $FCHECK ]
then
  echo "\$FCHECK is not set!  Stop installation"
  exit 1;
else
  echo " * ok, \$FCHECK set to $FCHECK";
fi


 echo " * ok, $RUNMCDIR  is used for the installation";

echo " "
echo -n "Do you wish to proceed [y or n] :"
read ANS
   case $ANS in
   y|Y|yes|Yes) echo "Yes is selected"
   ;;
   n|N) echo "No is selected" 
   exit 0
   ;;
   *) echo "`basename $0` : Unknown response" >&2
   exit 1
   ;;
 esac 
 
# check installation directory
if test -e $RUNMCDIR;
then
    echo " * ok, $RUNMCDIR found"
    echo "       RunMC will be installed to this directory"
else
       echo " * ok, "; mkdir -v $RUNMCDIR 
       echo "       RunMC will be installed to this directory"
fi

# check install directory
FCHECK=`ls $RUNMCDIR`; 
LL=`expr length "$FCHECK"`
if (("$LL" > 1));
then 
    echo "ERROR: $RUNMCDIR is not empty!"
    echo "Tip:   remove all directories in $RUNMCDIR manually and start this script again!"
    exit 1;
else
    echo " * ok, wait! All directories are copied to $RUNMCDIR"  
    cp -r $RUNMC/*  $RUNMCDIR
fi

echo "All done"
echo "RUNMC was installed to $RUNMCDIR"
echo "Exit root mode, and the run \"install_user.sh\" to create user directory"

exit

exit 0

