// * This code is licensed under:
// * JRunMC License, Version 1.0
// * - for license details see http://runmc.sourceforge.net/License.txt
// *
// * Copyright (c) 2005 by S.Chekanov (chekanov@mail.desy.de).
// * All rights reserved.

package JRunMC.hlookup;

import JRunMC.ui.*;
import JRunMC.util.*;

// colt library
import hep.aida.ref.*;


// Imports
import javax.swing.*;
import java.awt.*; 

/**
 * An example of how to embed a JAIDA IPlotter into your own application.
 */
public class AIDAEmbed extends JPanel
{

// histogram canvas
  private  static JCanvas c1;
  private  static Histogram1D h1D;
  private  static Histogram2D h2D;
 
  static float[] myarray;
  static float[] errors;

  private static native int jnipower(   int in_XBin,
                                        int in_YBin,
                                        String in_Title,
                                        float[] myarray,
                                        float[] errors);

  

   public static final long serialVersionUID = 802;

   /** Creates a new instance of AIDAEmbed */
   public AIDAEmbed()
   {

     super(new BorderLayout());
     c1 = new JCanvas(300,200);

     // store mainframe dimensions
    Dimension dim = Global.mainFrame.getSize();
    int w=(int)(0.8*dim.width);
    int h=(int)(0.5*dim.height);

/*
        dataset = createDataset("histogram","",1,0.0,1.0);
        chart = createChart(null);
        chartPanel = new ChartPanel(chart);
//        chartPanel.setLayout(new BorderLayout());
//        chartPanel.setMouseZoomable(true, false);
//        chartPanel.setPreferredSize(new java.awt.Dimension(300, 200));
*/

        this.add(c1);

   }


public  void MakeHisto (String T, String C, int BinX, double MinX, double MaxX, 
                                            int BinY, double MinY, double MaxY ) {

// get bins 

     double delX=(MaxX-MinX)/(double)BinX;
     double delY=0.0;
     if (BinY>0) delY=(MaxY-MinY)/(double)BinY; 

     if (BinY == 0) { 
      myarray = new float[BinX];
      errors  = new float[BinX];
     } else { 
      myarray = new float[BinX*BinY];
      errors  = new float[BinX*BinY];
     }

//     System.out.println("BinX="+BinX);
//     System.out.println("BinY="+BinY);


     int res = jnipower(BinX,BinY,T,myarray,errors);

// fill 1D histogram 
     if (res > 0 && BinX>0 && BinY==0) { 

// make 1D histogram
     h1D = new Histogram1D(T,BinX,MinX,MaxX);
     double[] x = new double[BinX];
     double[] y = new double[BinX];
     double[] err = new double[BinX];
// fill histogram 
     for (int i=0; i<BinX; i++) {
        double dd=MinX+delX*i;
        x[i]=dd+0.5*delX;
        y[i]=(double)myarray[i];
        err[i]=(double)errors[i];
     }
     h1D.setBinContent(x, y, err); 
   // draw 1D
     c1.Draw(h1D,"he", Color.green);
    }  // end 1 D histogram  


// fill 2D histogram
     if (res > 0 && BinX>0 && BinY>0) {

     h2D = new Histogram2D(T,BinX,MinX,MaxX,BinY,MinY,MaxY);

      double[][] x = new double[BinX][BinY];
      double[][] y = new double[BinX][BinY];
      double[][] err = new double[BinX][BinY];
      int kk=0;
// fill histogram
     for (int i=0; i<BinX; i++) {
        for (int j=0; j<BinY; j++) {
        double ddX=MinX+delX*i;
        double ddY=MinY+delY*j;
        x[i][j]=0.0;
        y[i][j]=(double)myarray[kk];
        err[i][j]=(double)errors[kk];
        kk++;
     }
     h2D.setBinContent(x, y, err);
   // draw 1D
     c1.Draw(h2D,"h", Color.green);
    }  // end 2 D histogram
    }





 } 


// load JNI interface library  
 static {

    String path=SetEnv.RUNDIR;
    if (SetEnv.OSsys.equals("windows") ) path=SetEnv.RUNDIRwin32;
  
    try {
       System.loadLibrary("hmoni");
    } catch (UnsatisfiedLinkError e) {
      System.out.println("Cannot link library $RUNMC/main/shmem/libhmoni.so!");
    }

  } // end static 


// draw histogram
public void  Draw(String type, Color CC) {
    c1.Draw(h1D,type,CC); 
 }

// Editor 
public void  EditJCanvas() {
   c1.EditJCanvas(); 
 }

// Print 
public void  PrintJCanvas() {
   c1.PrintJCanvas(); 
 }

// Save 
public void  SaveJCanvasPDF() {
   c1.SaveJCanvasPDF();
 }

// Save 
public void  SaveJCanvas() {
   c1.SaveJCanvas();
 }

// Axis 
public void  SetAxisY(String S1, String S2) {
   c1.SetAxisY(S1,S2);
 }

// Axis 
public void  SetAxisX(String S1, String S2) {
   c1.SetAxisX(h1D.title(),S2);
 }

// stat 
public void  SetStatBox() {
    c1.SetStatBox();
 }

// stat 
public void  removeStatBox() {
    c1.removeStatBox();
 }



}
