// * This code is licensed under:
// * JRunMC License, Version 1.0
// * - for license details see http://runmc.sourceforge.net/License.txt
// *
// * Copyright (c) 2005 by S.Chekanov (chekanov@mail.desy.de). 
// * All rights reserved.
// define your MC available 
package JRunMC.ui;

 import JRunMC.util.*;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import java.io.*;
import java.util.*;
import java.lang.*;
import java.text.*;


public class  RMCaction {
   
 private static String path="";




//  find RMC name in proj directory
  public static  String  getName() {

  path=SetEnv.RUNDIR;
  if (SetEnv.OSsys.equals("windows") ) path=SetEnv.RUNDIRwin32;

   String name=" "; 

   int NumMC=0;

// find name of this project file
   File proj = new File( path+File.separator+"proj" );
   String [] files = null;

   files = proj.list();
   if (files != null) { 
// find this name
    for(int i=0; i<files.length; i++) {
        if (files[i].endsWith(".mc") ) {
             name=files[i];
             // remove absolute path here
             name=StringUtil.replace(name, path+File.separator, "");
             name=StringUtil.replace(name, ".mc", "");
             NumMC++; 
        }

     }
   }


   if (NumMC>1) { 
   JOptionPane dialog = new JOptionPane();
             dialog.showMessageDialog(dialog,
             "Too many <project>.mc files. Make sure that there \n is only one such file in \"proj\" directory ", 
             "Warning", JOptionPane.WARNING_MESSAGE);
    }

    if (name.length()<3 && NumMC>1) name="none"; 

    return name;

    }







// save RMC package
  public static void save() {

  path=SetEnv.RUNDIR;
  if (SetEnv.OSsys.equals("windows") ) path=SetEnv.RUNDIRwin32;


// clean first project directory
   File proj = new File(path+File.separator+"proj");
   if (proj.exists() ) CleanProj();

// give some time to zip it
   try {
   Thread.sleep(200);
    } catch (Exception err) { }


// get name
    String name=getName();


// give some time to zip it
   try {
   Thread.sleep(100);
    } catch (Exception err) { }


//    System.out.println( "Name of the file "+name );

// now zip this file with proper name 
   String newrmc=path+File.separator+"archive"+File.separator+name+".rmc";
   Util.JarDirectory(path+File.separator+"proj", newrmc, path+File.separator);




  } // end save














// load RMC package 
  public static void load( String inputfile ) { 

   path=SetEnv.RUNDIR;
   if (SetEnv.OSsys.equals("windows") ) path=SetEnv.RUNDIRwin32;

// clean first unnecesary project files 
   File sproj = new File(path+File.separator+"proj");
   if (sproj.exists() && sproj.isDirectory() ) CleanProj();

// backup it
// Get today's date
   Format formatter;
   Date date = new Date();
   formatter = new SimpleDateFormat("yyyy_MM_dd_HH_mm_ss");
   String s = formatter.format(date);

   String oldrmc=path+File.separator+"main"+File.separator+"tmp"+File.separator+s+".rmc"; 
   Util.JarDirectory(path+File.separator+"proj", oldrmc, path+File.separator); 



// this will remove ALL files from this directory 
  if (sproj.exists() && sproj.isDirectory() )  RemoveProj(); 

 
// unzip file 
//   String output="";
//   String ss=path+File.separator+"archive"+File.separator+inputfile;
//   Util.unzipDir(ss, path); 

// this is ala unix
//    UnzipRMC(inputfile);

    String sinput=path+File.separator+"archive"+File.separator+inputfile;

    try {
     Unzipper.unzip(sinput, null, new File(path));
    } catch (Exception err) {
      System.out.println( "Error in Unzipper.unzip");
      err.printStackTrace();
   }


// give some time to zip it 
   try {
   Thread.sleep(100);
    } catch (Exception err) { } 


// clean exe files
   CleanExe();


   File fmake1= new File (path+File.separator+"proj"+File.separator+"Makefile");
   File fmake2= new File (path+File.separator+"proj"+File.separator+"makefile");

   if (fmake1.exists() || fmake2.exists() ) {

// execute make
   String sh = "bash"; String cop = "-c";

   String unixpath=SetEnv.RUNDIR;


   String cmd0 = "chmod -R 755 "+unixpath+"/proj";
// make executables 
   try {
    String[] exe0 = new String[] {sh, cop, cmd0};
    Process p = Runtime.getRuntime().exec(exe0);
   } catch (Exception err) {
     System.out.println( "Error in "+cmd0 );
     err.printStackTrace();
   }


   String cmd1 = "make -C "+unixpath+"/proj &> "+ unixpath+"/proj/install.log &";
// make all  
   try {
    String[] exe1 = new String[] {sh, cop, cmd1};
    Process p = Runtime.getRuntime().exec(exe1);
   } catch (Exception err) {
     System.out.println( "Error in "+cmd1 );
     err.printStackTrace();
   }

  } // endif


 }








// clean all unnecessry files in the project idirectory
  public static void CleanProj() {

   boolean succ=true;
   String path=SetEnv.RUNDIR;
   if (SetEnv.OSsys.equals("windows") ) path=SetEnv.RUNDIRwin32;


// first try the standrd make clean from the proj directory  
   String sh = "bash"; String cop = "-c";



// call external cleaner
// in proj_clean.sh you can set user-specific options
   String cmd3 = path+"/main/scripts/proj_clean.sh &> /dev/null";
   File fcleaner1= new File (path+"/main/scripts/proj_clean.sh");

   if (fcleaner1.exists() ) {
// do make clean first
    try {
    String[] exe3 = new String[] {sh, cop, cmd3};
    Process p = Runtime.getRuntime().exec(exe3);
    } catch (Exception err) {
    System.out.println( "Error in "+cmd3 );
    err.printStackTrace();
   }
  } // end of proj_clean.sh


// This is JAVA-based cleaner 
// it may not not work well for JRE 1.5  
   String cmd1 = "make clean -C "+path+File.separator+"proj &> /dev/null";
   File fmake1= new File (path+File.separator+"proj"+File.separator+"Makefile");
   File fmake2= new File (path+File.separator+"proj"+File.separator+"makefile");

   if (fmake1.exists() && fmake2.exists() ) { 
// do make clean first
   try {
    String[] exe1 = new String[] {sh, cop, cmd1};
    Process p = Runtime.getRuntime().exec(exe1);
   } catch (Exception err) {
    System.out.println( "Error in "+cmd1 );
   err.printStackTrace();
   }
  }


/*
// first  remove 3 links manually  
     File s1 = new File(path+File.separator+"proj"+File.separator+".runmc.log");
     File s2 = new File(path+File.separator+"proj"+File.separator+".runmc.in");
     File s3 = new File(path+File.separator+"proj"+File.separator+".runmc.out");
     if (s1.exists() ) succ =s1.delete();
     if (s2.exists() ) succ =s2.delete();
     if (s3.exists() ) succ =s3.delete();

// then remove the rest 
    File proj = new File( path+File.separator+"proj" );
    String [] files = null;

    files = proj.list();

    if (files != null ) {
    for(int i=0; i<files.length; i++) {
    
         String ss = path+File.separator+"proj"+File.separator+files[i];  
         File sfile = new File( ss );  
         if (files[i].endsWith(".root") ) succ =sfile.delete();  
         if (files[i].endsWith(".log")  ) succ =sfile.delete();
         if (files[i].endsWith(".err")  ) succ =sfile.delete();
         if (files[i].endsWith(".o")    ) succ =sfile.delete();
         if (files[i].endsWith("~")     ) succ =sfile.delete();
         if (files[i].endsWith("bak")   ) succ =sfile.delete();
         if (files[i].endsWith(".htup")  ) succ =sfile.delete();
         if (files[i].endsWith(".rtup")  ) succ =sfile.delete();
    //       System.out.println( files[i] ); 
     }
     }

// clean ini
    File projini = new File( path+File.separator+"proj"+File.separator+"ini" );
    String [] filesini = null;

    filesini = projini.list();
    if (filesini != null ) {

    for(int i=0; i<filesini.length; i++) {

         String ss=path+File.separator+"proj"+File.separator+"ini"+File.separator+filesini[i];
         File sfile = new File( ss );
         if (filesini[i].endsWith(".o") )   succ =sfile.delete();
         if (filesini[i].endsWith("~")  )   succ =sfile.delete();
         if (filesini[i].endsWith("bak") )  succ =sfile.delete();
     //    System.out.println( filesini[i] );
      }
    }

*/


} // end Clean    



// clean all exe  files
  public static void CleanExe() {
    
//     System.out.println(  "CleanExe()"  );

   String path=SetEnv.RUNDIR;
   if (SetEnv.OSsys.equals("windows") ) path=SetEnv.RUNDIRwin32;

     boolean succ=true;
// then remove the rest
     File exef = new File( path+File.separator+"bin" );
     String [] files = null;
     files = exef.list();
     if ( files != null) {
      for(int i=0; i<files.length; i++) {
        File sfile = new File(path+File.separator+"bin"+File.separator+files[i]);
         if (files[i].startsWith("runmc.") && sfile.length()>2000 ) {
          // System.out.println(  files[i]  ); 
           succ =sfile.delete();
         }
     } 
    } // end if 

   }// end CleanExe 


// remove all files and directories in proj directory
  public static void RemoveProj() {


/*
   // execute make
   String sh = "bash"; String cop = "-c";

   String unixpath=SetEnv.RUNDIR;
   String cmd = "rm -r "+unixpath+"/proj/*";
   String[] exe = new String[] {sh, cop, cmd};

// do make clean first
   try {
    Process p = Runtime.getRuntime().exec(exe);
   } catch (Exception err) {
    //  System.out.println( "Error in "+cmd0 );
    //  err.printStackTrace();
   }
*/

   boolean succ=true;
   String path=SetEnv.RUNDIR;
   if (SetEnv.OSsys.equals("windows") ) path=SetEnv.RUNDIRwin32;

// find name of this project file
   File files = new File( path+File.separator+"proj");
   File  [] sfiles =  null;
   sfiles =  files.listFiles();

// remove files
    if (sfiles != null) { 
    for(int i=0; i<sfiles.length; i++) {
       if ( !sfiles[i].isDirectory() )  sfiles[i].delete();
       if (  sfiles[i].isDirectory() )  succ=Util.deleteDir( sfiles[i] ); 
       }
     }

   } 




// unzip all the files using UNIX zip 
 public static void UnzipRMC( String input ) {


   String unixpath=SetEnv.RUNDIR;
   String inputfile=SetEnv.RUNDIR+"/archive/"+input;

//   System.out.println( "File to unzip "+ inputfile );
 
   // execute make
   String sh = "bash"; String cop = "-c";
   String cmd = "unzip -q -o "+inputfile+" -d "+unixpath;
   String[] exe = new String[] {sh, cop, cmd};
   try {
    Process p = Runtime.getRuntime().exec(exe);
   } catch (Exception err) {
    //  System.out.println( "Error in "+cmd0 );
    //  err.printStackTrace();
   }


 }









     
     
}
