
       SUBROUTINE runmcarlo(IRUN, ierr)

C from C++ interface 
C      IRUN=1 - initialize
C      IRUN=2 - run
C      IRUN=3 - terminate
C      ierr- no errors, event accepted 
C      written by S.Chekanov, May, 2003

      include "../mcarlo/inc/aroma22.inc" 
      include "../mcarlo/inc/jetset74_aroma.inc"
      include "../inc/hepevt_pythia57.inc"
      include "../inc/getevkin.inc"
      include "../inc/getseeds.inc"
 
      Integer I, J, nev, IPOSI
      Real pbeam(4), ebeam(4) 
      Integer IRUN,ierr,IPAR
      Save nev 


      goto (1000, 2000, 3000) IRUN
      return

 1000   CONTINUE 


*-initialize selection
C--  AROMA parameters:

      xCross=0.
      eCross=0.

       CALL LUGIVE('PARJ(72)=1000') ! mm maximum distance from the origin at
                     ! a decay is allowed to take place
       CALL lUGIVE('MSTJ(22)=3')  ! particle is decayed only if the decay vertex is
                     ! within a distance PARJ(72) of the origin
       write(6,*)PARJ(72),'mm maximum distance a decay is allowed'

C set seed number
      MRLU(1)=RUNMCseed1+RUNMCseed2
      write(6,*) "AROMA: new seed for this run = ",MRLU(1)


C--   Min pt for produced Q (and Qbar)
      PTCUT=0.2
      PARHFL(4)=PTCUT**2
C--       Heavy flavour treatment (D=2): 0->normal events, no heavy flavours
C--       1->normal events + heavy flavours, 2->only heavy flavours.
      LSTHFL(1)=2
C--       Lightest and heaviest flavour to be produced in NC (D=4,5)

C charm
C      LSTHFL(2)=4
C      LSTHFL(3)=5
C      LSTHFL(2)=5
C      LSTHFL(3)=6


C--       CC flavour switch: Ics + 10*Icb + 100*Its + 1000*Itb (D=11).
      LSTHFL(6)=11
C--       QCD for HFL events: 1->ME, 2-> ME+PS
      LSTHFL(8)=2

C--       Strange, charm, bottom, top quark masses
      PMAS(3,1)=0.5
      PMAS(4,1)=1.5
      PMAS(5,1)=5.0
      PMAS(6,1)=175.0

*- set charm mass ..
       PMAS(4,1)=1.5  ! does not work for IC


*-take positron (default) 
       IPOSI=-11
       nev=0
       ierr=1


       CUTHFL(5)=rXbj(2)  ! min X
       CUTHFL(6)=rXbj(3)  ! max X
       CUTHFL(1)=rYbj(2)  ! min Y 
       CUTHFL(2)=rYbj(3)  ! max Y 
       CUTHFL(3)=rQ2(2)  ! min Q2
       CUTHFL(4)=rQ2(3)  ! max Q2
*       CUTHFL(7)=rW2(2)  ! min W 
*       CUTHFL(8)=rW2(3)  ! max W


        MSTU(11)=6
        LST(16)=2
        LST(18)=4
        IF (PDF1.eq.1.or.PDF2.eq.1)  LST(15)=10050 ! CTEQ6m (central value)
        IF (PDF1.eq.2.or.PDF2.eq.2)  LST(15)=20450 ! MRST2004FF4lo
        IF (PDF1.eq.3.or.PDF2.eq.3)  LST(15)=80051 ! GRV 98 NLO

 
* redefine initial lepton  
        IF (abs(PID1).le.14) THEN
             IPOSI=PID1
             ebeam(1)=0.
             ebeam(2)=0.
             ebeam(3)=-1*ENER1
             ebeam(4)=ENER1
           pbeam(1)=0.
           pbeam(2)=0.
           pbeam(3)=ENER2
           pbeam(4)=ENER2
         ENDIF
 
       IF (abs(PID2).le.14) THEN
             IPOSI=PID2
             ebeam(1)=0.
             ebeam(2)=0.
             ebeam(3)=-1*ENER2
             ebeam(4)=ENER2
           pbeam(1)=0.
           pbeam(2)=0.
           pbeam(3)=ENER1
           pbeam(4)=ENER1
         ENDIF


*         write(6,*) 'Lepton energy:'
*         write(6,*) 'ebeam(1)=',ebeam(1)
*         write(6,*) 'ebeam(2)=',ebeam(2)
*         write(6,*) 'ebeam(3)=',ebeam(3)
*         write(6,*) 'ebeam(4)=',ebeam(4) 
*         write(6,*) 'Proton energy:'
*         write(6,*) 'pbeam(1)=',pbeam(1)
*         write(6,*) 'pbeam(2)=',pbeam(2)
*         write(6,*) 'pbeam(3)=',pbeam(3)
*         write(6,*) 'pbeam(4)=',pbeam(4)



C  set parameters via cards
        Call RunMC_Steer("aroma22.cards")
        Call RunMCaromasteer

C set user initialisation
        Call setAROMA22



C--       initialise AROMA
        CALL AROINI(0,IPOSI,ebeam(3),pbeam(3),4)


       write(6,*) ' FINISH INITIALIZATION'

      RETURN

 2000  CONTINUE  ! RUN 
************* Physical study *************** 

C...Call generate an event with LEPTO
        CALL AROMA
        IF (LST(21).ne.0) THEN
          NHEP=-1
          goto 9999
        ENDIF 

        nev=nev+1
C copy kinematic varaibles
        ierr=0        
        rQ2(1)=Q2
        rXbj(1)=X
        rYbj(1)=Y 
        rW(1)=sqrt(W2)
         
         call lutabu(11) 
C.. convert from JETSET common
        CALL LUHEPC(1)
C...Call a user supplied analysis routine
        if (nev.le.5)  CALL LULIST(1) 

C to check  
C        write(6,*) ' ' 
C        write(6,*) 'Total number in HEPEVT=',NHEP 
C        do i=1,NHEP
C        write(6,*) i, IDHEP(i),PHEP(1,i),PHEP(2,i),PHEP(3,i) 
C        enddo 

 9999  Continue
* end of loop >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
      RETURN


 3000 CONTINUE

      Call lutabu(12)
      xCross=PARHFL(6)
      eCross=0. 
      write(6,*) 'RUNMC-AROMA: Total cross section (pb): ', xCross 

      write(6,*) 'RUNMC-AROMA: ALL done!'

      RETURN      
      END  
 
