CDECK  ID>, HWH2F3
*CMZ :-        -27/02/01  17:04:16  by  Peter Richardson
C-----------------------------------------------------------------------
      SUBROUTINE HWH2F3(NP,F,P,MQ)
C-----------------------------------------------------------------------
C     Subroutine to implement the F function of Eijk and Kliess
C     All first and second momenta
C-----------------------------------------------------------------------
      INCLUDE 'HERWIG65.INC'
      DOUBLE PRECISION P(5),MQ,PM(5),XMASS,PLAB,PRW,PCM,HWULDO,PDOT,EPS
      DOUBLE COMPLEX F(2,2,8,8),SIP(2),SJP(2),S,D
      INTEGER I,J,NP
      COMMON/HWHEWS/S(8,8,2),D(8,8)
      COMMON/HWHEWP/XMASS(10),PLAB(5,10),PRW(5,2),PCM(5,10)
      EXTERNAL HWULDO
      PARAMETER(EPS=1D-10)
C--find the massless momentum we need
      DO I=1,NP
        PDOT = HWULDO(PCM(1,I),P)
        P(5) = P(4)**2-P(1)**2-P(2)**2-P(3)**2
        IF(ABS(PDOT).LT.EPS.AND.ABS(P(5)).LT.EPS) THEN
           PDOT = HALF
        ELSE
           PDOT = HALF*P(5)/PDOT
        ENDIF
        DO J=1,4
          PM(J) = P(J)-PDOT*PCM(J,I)
        ENDDO
        IF(P(5).GT.ZERO) THEN
           P(5)=SQRT(P(5))
        ELSE
           P(5)=ZERO
        ENDIF
        PM(5) = ZERO
C--calculate its spinor product with the fixed momentum
        CALL HWH2SS(SIP,PCM(1,I),PM)
C--calculate the F functions
        DO J=I,NP
          CALL HWH2SS(SJP,PM,PCM(1,J))
          F(1,1,I,J) = SIP(1)*SJP(2)
          F(1,2,I,J) = MQ*S(I,J,1)
          F(2,1,I,J) = MQ*S(I,J,2)
          F(2,2,I,J) = SIP(2)*SJP(1)
        ENDDO
      ENDDO
      DO I=1,NP
        DO J=I+1,NP
          F(1,1,J,I) =  F(2,2,I,J)
          F(1,2,J,I) = -F(1,2,I,J)
          F(2,1,J,I) = -F(2,1,I,J)
          F(2,2,J,I) =  F(1,1,I,J)
        ENDDO
      ENDDO
      END
