C
C
      SUBROUTINE PCODES
C**********************************************************************
C
C     debug particle codes of BAMJET and PDG,
C
C**********************************************************************
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      SAVE
C
      CHARACTER*8 ANAME
      COMMON /POPART/ANAME(187),AM(187),GA(187),TAU(187),ICH(187),
     &               IBAR(187),K1(187),K2(187)
C
      CHARACTER*16 JETNAM
      DIMENSION IETAB(10)
      DATA IETAB /2,-1,-1,2,0,0,-2,1,1,-2/
C
      WRITE(6,'(/1X,A)') 'PCODES:PARTICLE NUMBER DEBUG/CHECK'
C
C  determine quark contents
C  check meson table
      WRITE(6,'(3(/1X,A)/)') 'QUARK INDEX TABLE BAMJET',
     &                       '========================',
     &  '1 - u, 2 - d, 3 - s, c - 4, 7 - au, 8 - ad, 9 - as, 10 - ac'
      WRITE(6,'(/1X,A/)')
     &  '  BAM-ID  NAME      Q1  Q2  Q3    MASS    PDG-ID CHARGE'
      DO 100 I=1,4
        DO 200 K=7,10
          II = I
          KK = K
          ICHARG = (IETAB(II)+IETAB(KK))/3
          CALL POMEMA(II,KK,AMPS,AMPS2,AMVE,AMVE2,IPS,IVE)
          WRITE(6,'(1X,I6,3X,A8,3I4,E12.3,I6,I3)')
     &      IPS,ANAME(IPS),II,KK,0,AMPS,MPDGHA(IPS),ICH(IPS)
          IF(ICHARG.NE.ICH(IPS)) THEN
            WRITE(6,'(1X,A,/,1X,I4,A,2I5)')
     &        'PCODES:ERROR: INCONSISTENT CHARGE',IPS,ANAME(IPS),
     &        ICHARG,ICH(IPS)
          ENDIF
          WRITE(6,'(1X,I6,3X,A8,3I4,E12.3,I6,I3)')
     &      IVE,ANAME(IVE),II,KK,0,AMVE,MPDGHA(IVE),ICH(IVE)
          IF(ICHARG.NE.ICH(IVE)) THEN
            WRITE(6,'(1X,A,/,1X,I4,A,2I5)')
     &        'PCODES:ERROR: INCONSISTENT CHARGE',IVE,ANAME(IVE),
     &        ICHARG,ICH(IVE)
          ENDIF
 200    CONTINUE
 100  CONTINUE
C  check baryon table
      DO 300 I=1,4
        DO 400 J=I,4
          DO 500 K=J,4
            ICHARG = (IETAB(I)+IETAB(J)+IETAB(K))/3
            CALL POBAMA(I,J,K,AM8,AM82,AM10,AM102,I8,I10)
            WRITE(6,'(1X,I6,3X,A8,3I4,E12.3,I6,I3)')
     &        I8,ANAME(I8),I,J,K,AM8,MPDGHA(I8),ICH(I8)
            IF(ICHARG.NE.ICH(I8)) THEN
              WRITE(6,'(1X,A,/,1X,I4,A,2I5)')
     &          'PCODES:ERROR: INCONSISTENT CHARGE',I8,ANAME(I8),
     &          ICHARG,ICH(I8)
            ENDIF
            WRITE(6,'(1X,I6,3X,A8,3I4,E12.3,I6,I3)')
     &        I10,ANAME(I10),I,J,K,AM10,MPDGHA(I10),ICH(I10)
            IF(ICHARG.NE.ICH(I10)) THEN
              WRITE(6,'(1X,A,/,1X,I4,A,2I5)')
     &          'PCODES:ERROR: INCONSISTENT CHARGE',I10,ANAME(I10),
     &          ICHARG,ICH(I10)
            ENDIF
            II = I + 6
            JJ = J + 6
            KK = K + 6
            ICHARG = (IETAB(II)+IETAB(JJ)+IETAB(KK))/3
            CALL POBAMA(II,JJ,KK,AM8,AM82,AM10,AM102,I8,I10)
            WRITE(6,'(1X,I6,3X,A8,3I4,E12.3,I6,I3)')
     &        I8,ANAME(I8),II,JJ,KK,AM8,MPDGHA(I8),ICH(I8)
            IF(ICHARG.NE.ICH(I8)) THEN
              WRITE(6,'(1X,A,/,1X,I4,A,2I5)')
     &          'PCODES:ERROR: INCONSISTENT CHARGE',I8,ANAME(I8),
     &          ICHARG,ICH(I8)
            ENDIF
            WRITE(6,'(1X,I6,3X,A8,3I4,E12.3,I6,I3)')
     &        I10,ANAME(I10),II,JJ,KK,AM10,MPDGHA(I10),ICH(I10)
            IF(ICHARG.NE.ICH(I10)) THEN
              WRITE(6,'(1X,A,/,1X,I4,A,2I5)')
     &          'PCODES:ERROR: INCONSISTENT CHARGE',I10,ANAME(I10),
     &          ICHARG,ICH(I10)
            ENDIF
 500      CONTINUE
 400    CONTINUE
 300  CONTINUE
C
      WRITE(6,'(2(/1X,A)/)') 'PARTICLE TRANSLATION TABLE',
     &                       '=========================='
      WRITE(6,'(1X,A)')
     &  'QUARKS: 1 - d,  2 - u,  3 - s,  4 - c,  5 - b,  6 - t'
      WRITE(6,'(1X,A)')
     &  'PDG-ID   NAME  JETSET-NAME  BAM-ID  CHARGE   QUARKS'
C
      DO 600 I=1,187
        IPDG = MPDGHA(I)
        JETNAM = '              '
        IF(IPDG.NE.99999) CALL LUNAME(IPDG,JETNAM)
        WRITE(6,'(1X,I8,2X,A,2X,A16,I5,I5,3X,3I3)')
     &    IPDG,ANAME(I),JETNAM,I,ICH(I),(IPDGQU(K,I),K=1,3)
*       WRITE(6,'(1X,I5,2X,A,I8,E12.3,I4,3X,3I3)')
*    &    I,ANAME(I),MPDGHA(I),AM(I),ICH(I),(IPDGQU(K,I),K=1,3)
 600  CONTINUE
      WRITE(6,'(/)')
C
      END
