C
C
      SUBROUTINE POBAMA(I,J,K,AM8,AM82,AM10,AM102,I8,I10)
C**********************************************************************
C
C     determine baryon masses corresponding to the input flavours
C
C     input: I,J,K     1,2,3,4 -->  u/d/s/c
C                      7,8,9,10     au/ad/as/ac
C                               (other flavours are not supported)
C            attention: diquark will be built up from first two flavours
C
C
C     output: AM8      octett baryon mass
C             AM82     next possible two particle configuration
C                      (octett baryon and meson)
C             AM10     decuplett baryon mass
C             AM102    next possible two particle configuration
C                      (decuplett baryon and meson)
C             I8,I10   baryon numbers in BAMJET
C
C**********************************************************************
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      SAVE
C
      PARAMETER (NMAXD=100)
      COMMON /DEBUG/ IDEB(NMAXD),KSPOM,KHPOM,KSREG,KHDIR,KACCEP,
     &  KSTRG,KHTRG,KSLOO,KHLOO,KSDPO,KHDPO,KEVENT,KSOFT,KHARD
C
      CHARACTER*8 ANAME
      COMMON/POPART/ANAME(187),AM(187),GA(187),TAU(187),ICH(187),
     &              IBAR(187),K1(187),K2(187)
      COMMON/INPDAT/IMPS(6,6),IMVE(6,6),IB08(6,21),IB10(6,21),
     *IA08(6,21),IA10(6,21),A1,B1,B2,B3,LT,LB,ISU,IYQ,BET,AS,B8,AME,DIQ
C
      IF(I.GT.6) THEN
C  antibaryon
        II = I -6
        JJ = J -6
        KK = K -6
        IABAR = 1
      ELSE
C  baryon
        II = I
        JJ = J
        KK = K
        IABAR = 0
      ENDIF
C
C  find index
      CALL INDEX2(II,JJ,IND)
      IF(IABAR.EQ.1) THEN
C  antibaryon
        I8  = IA08(KK,IND)
        I10 = IA10(KK,IND)
      ELSE
C  baryon
        I8  = IB08(KK,IND)
        I10 = IB10(KK,IND)
      ENDIF
C  masses (if combination possible)
      IF (I8.LE.0) I8=I10
      AM8  = AM(I8)
      AM10 = AM(I10)
C
C  find next possible two particle configuration (insert q qbar system)
      AM82  = 1000.D0
      AM102 = 1000.D0
      DO 100 L=1,4
        IF(IABAR.EQ.1) THEN
C  antibaryon
          K8  = IA08(L,IND)
          K10 = IA10(L,IND)
          AMM = MIN(AM(IMPS(KK,L)),AM(IMVE(KK,L)))
        ELSE
C  baryon
          K8  = IB08(L,IND)
          K10 = IB10(L,IND)
          AMM = MIN(AM(IMPS(L,KK)),AM(IMVE(L,KK)))
        ENDIF
        IF (K8.LE.0) K8=K10
        AM82  = MIN(AM82, AM(K8) + AMM)
        AM102 = MIN(AM102, AM(K10) + AMM)
 100  CONTINUE
C  add phase space
      AM82  = AM82*1.5D0
      AM102 = AM102*1.1D0
      END
