C
C
      SUBROUTINE POMCIN(JM1,JM2)
C********************************************************************
C
C     initialization of MC event generation
C
C********************************************************************
      IMPLICIT DOUBLE PRECISION(A-H,O-Z)
      SAVE
      PARAMETER (ZERO   =  0.D0,
     &           ONE    =  1.D0,
     &           TWO    =  2.D0,
     &           OHALF  =  0.5D0,
     &           PIMASS =  0.13D0,
     &           TINY   =  1.D-10)
C
      PARAMETER (NMAXD=100)
      COMMON /DEBUG/ IDEB(NMAXD),KSPOM,KHPOM,KSREG,KHDIR,KACCEP,
     &  KSTRG,KHTRG,KSLOO,KHLOO,KSDPO,KHDPO,KEVENT,KSOFT,KHARD
      CHARACTER*8 MDLNA
      COMMON /MODELS/ MDLNA(50),ISWMDL(50),PARMDL(200),IPAMDL(200)
      COMMON /PROCES/ IPROCE,IDNODF,IDIFR1,IDIFR2,IDDPOM,IPRON(15)
      COMMON /XSECTP/ SIGTOT,SIGELA,SIGVM(0:4,0:4),SIGINE,SIGDIR,
     &                SIGLSD(2),SIGHSD(2),SIGLDD,SIGHDD,SIGCDF,
     &                SIGPOM,SIGREG,SIGHAR,SIGTR1,SIGTR2,SIGLOO,SIGDPO,
     &                SIG1SO,SIG1HA,SLOEL,SLOVM(4,4),SIGGEN(4),
     &                FSUP(2)
      PARAMETER (MAXPRO = 16, MAXTAB = 20)
      COMMON /HAXSEC/ XSECTA(4,-1:MAXPRO,4,MAXTAB),XSECT(6,-1:MAXPRO),
     &                MXSECT(0:4,-1:MAXPRO,4),ECMSH(4,MAXTAB),ISTTAB
      COMMON /GLOCMS/ ECM,PCM,PMASS(2),PVIRT(2),IFPAP(2),IFPAB(2)
      COMMON /CUTOFF/ PTCUT(4),CUTMU(4),FPS(4),FPH(4),PSOMIN,XSOMIN
C
      PARAMETER (IEETAB=20,IIMAX=30,KKMAX=10)
      REAL PROB
      COMMON /PROBAB/ PROB(4,IEETAB,0:IIMAX,0:KKMAX),EPTAB(4,IEETAB),
     &                IEEMAX,IMAX,KMAX
      COMMON /XSETAB/ SIGTAB(4,70,IEETAB),SIGECM(4,IEETAB),ISIMAX
C
      CHARACTER*8 PANAME
      DIMENSION ECMF(4)
C
C  initialize fragmentation
      CALL POFRIN
C
C  reset interpolation tables
      DO 50 I=1,4
        DO 60 J=1,10
          DO 70 K=1,70
            SIGTAB(I,K,J) = ZERO
 70       CONTINUE
          SIGECM(I,J) = ZERO
 60     CONTINUE
 50   CONTINUE
C  max number of allowed colors (large N expansion)
      IC1 = 0
      IC2 = 10000
      CALL SELCOL(IC1,IC2,0,0,0,0,-1)
C  lower energy limit of initialization
      ETABLO = PARMDL(19)
      IF(ECM.LE.5.D0) ETABLO = MIN(2.D0,ETABLO)
C
      WRITE(6,'(/,1X,A,2F12.1)')
     &  'POMCIN:DEBUG:SELECTED ENERGY RANGE (SQRT(S))',ETABLO,ECM
      WRITE(6,'(5X,A,A,F7.3,E15.4)')
     &  'PARTICLE 1 (NAME,MASS,VIRTUALITY): ',PANAME(JM1,2),
     &  PMASS(1),PVIRT(1)
      WRITE(6,'(5X,A,A,F7.3,E15.4)')
     &  'PARTICLE 2 (NAME,MASS,VIRTUALITY): ',PANAME(JM2,2),
     &  PMASS(2),PVIRT(2)
C  cuts on probabilities of multiple interactions
      IMAX = MIN(IPAMDL(32),IIMAX)
      KMAX = MIN(IPAMDL(33),KKMAX)
      AH = 2.D0*PTCUT(1)/ECM
      IMAX = MAX(5,MIN(IMAX,INT(ECM/2.0D0)))
      KMAX = MIN(KMAX,1+INT(0.9*ONE/AH))
C  hard interpolation table
      ISTTAB = MIN(IPAMDL(30),MAXTAB)
      IF(ECM.LT.100.D0) ISTTAB = MIN(ISTTAB,15)
      IF(ECM.LT.50.D0)  ISTTAB = MIN(ISTTAB,10)
      IF(ECM.LT.10.D0)  ISTTAB = MIN(ISTTAB,5)
      ECMF(1) = ECM
      ECMF(2) = 0.9D0*ECMF(1)
      ECMF(3) = ECMF(2)
      ECMF(4) = ECMF(2)
      CALL POHMCI(ECMF)
C  dimension of interpolation table of cut probabilities
      IEEMAX = MIN(IPAMDL(31),IEETAB)
      IF(ECM.LT.100.D0) IEEMAX = MIN(IEEMAX,15)
      IF(ECM.LT.50.D0)  IEEMAX = MIN(IEEMAX,10)
      IF(ECM.LT.10.D0)  IEEMAX = MIN(IEEMAX,5)
      ISIMAX = IEEMAX
C  calculate probability distribution
      I0 = 4
      IF(ISWMDL(2).EQ.0) I0 = 1
      DO 150 IP=I0,1,-1
      ECMPRO = ECMF(IP)*1.001D0
      IF(IEEMAX.GT.1) THEN
        ELMIN = LOG(ETABLO)
        EDELTA = (LOG(ECMPRO)-ELMIN)/DBLE(MAX(1,IEEMAX-1))
        DO 100 I=1,IEEMAX
          ECMPRO = EXP(ELMIN+DBLE(I-1)*EDELTA)
          CALL PRBDIS(IP,ECMPRO,I)
 100    CONTINUE
      ELSE
        CALL PRBDIS(IP,ECMPRO,1)
      ENDIF
      IF(((IDEB(62).GE.0).AND.(IP.EQ.1)).OR.(IDEB(62).GE.1)) THEN
      WRITE(6,'(/1X,A,I3/1X,A,/1X,A)')
     &'POMCIN:TOTAL CROSS SECTIONS (mb) FOR PARTICLE COMBINATION',IP,
     &' ECM    SIGTOT  SIGELA  SIGINE  SIGQEL  SIGSD1  SIGSD2  SIGDD',
     &'============================================================='
      DO 200 I=1,IEEMAX
        WRITE(6,'(1X,8(1PE9.2))') SIGECM(IP,I),SIGTAB(IP,1,I),
     &    SIGTAB(IP,2,I),SIGTAB(IP,28,I),SIGTAB(IP,3,I),
     &    SIGTAB(IP,30,I)+SIGTAB(IP,32,I),
     &    SIGTAB(IP,31,I)+SIGTAB(IP,33,I),
     &    SIGTAB(IP,34,I)+SIGTAB(IP,35,I)
 200  CONTINUE
      ENDIF
      IF(IDEB(62).GE.1) THEN
      WRITE(6,'(/1X,A,I3/1X,A,/1X,A)')
     &'POMCIN:PARTIAL CROSS SECTIONS (mb) FOR PARTICLE COMBINATION',IP,
     &' ECM    SIGSD1L SIGSD1H SIGSD2L SIGSD2H SIGDDL  SIGDDH  SIGCDF',
     &'=============================================================='
      DO 205 I=1,IEEMAX
        WRITE(6,'(1X,8(1PE9.2))') SIGECM(IP,I),SIGTAB(IP,30,I),
     &    SIGTAB(IP,32,I),SIGTAB(IP,31,I),SIGTAB(IP,33,I),
     &    SIGTAB(IP,34,I),SIGTAB(IP,35,I),SIGTAB(IP,36,I)
 205  CONTINUE
      ENDIF
      IF(IDEB(62).GE.2) THEN
      WRITE(6,'(/1X,A,I3/1X,A,/1X,A)')
     &'POMCIN:BORN GRAPH X-SECTIONS (mb) FOR PARTICLE COMBINATION',IP,
     &' ECM    SIGSVDM SIGHRES SIGHDIR SIGTR1  SIGTR2  SIGLOO SIGDPO',
     &'============================================================='
      DO 210 I=1,IEEMAX
        WRITE(6,'(1X,8(1PE9.2))') SIGECM(IP,I),
     &    SIGTAB(IP,56,I)+SIGTAB(IP,57,I),SIGTAB(IP,58,I),
     &    SIGTAB(IP,59,I),SIGTAB(IP,60,I),SIGTAB(IP,61,I),
     &    SIGTAB(IP,62,I),SIGTAB(IP,63,I)
 210  CONTINUE
      WRITE(6,'(/1X,A,I3/1X,A,/1X,A)')
     &'POMCIN:UNITARIZED X-SECTIONS (mb) FOR PARTICLE COMBINATION',IP,
     &' ECM    SIGSVDM SIGHVDM  SIGTR1  SIGTR2  SIGLOO SIGDPO  SLOPE',
     &'============================================================='
      DO 215 I=1,IEEMAX
        WRITE(6,'(1X,8(1PE9.2))') SIGECM(IP,I),SIGTAB(IP,69,I),
     &    SIGTAB(IP,70,I),SIGTAB(IP,32,I),SIGTAB(IP,33,I),
     &    SIGTAB(IP,35,I),SIGTAB(IP,36,I),SIGTAB(IP,39,I)
 215  CONTINUE
      ENDIF
      IF(IDEB(62).GE.1) THEN
      WRITE(6,'(/1X,A,/1X,A,/1X,A)')
     &'POMCIN:EXPECTED AVERAGE NUMBER OF CUTS IN NON-DIFF EVENTS:',
     &' ECM  POM-S / POM-H / REG / ENH-TRL / ENH-DBLE',
     &'=============================================='
      DO 220 I=1,IEEMAX
        WRITE(6,'(1X,6(1PE9.2))') SIGECM(IP,I),SIGTAB(IP,64,I),
     &    SIGTAB(IP,65,I),SIGTAB(IP,66,I),SIGTAB(IP,67,I),
     &    SIGTAB(IP,68,I)
 220  CONTINUE
      ENDIF
 150  CONTINUE
C  simulate only hard scatterings
      IF(ISWMDL(2).EQ.0) THEN
        WRITE(6,'(2(/1X,A))') 
     &    'WARNING: GENERATION OF HARD SCATTERINGS ONLY!',
     &    '============================================='
        DO 155 I=2,7
          IPRON(I) = 0
 155    CONTINUE
        SIGGEN(4) = 0.D0
        DO 160 I=1,IEEMAX
          SIGMAX = 0.D0
          IF(IPRON(1).EQ.1) SIGMAX = SIGTAB(1,58,I)
          IF(IPRON(8).EQ.1) SIGMAX = SIGMAX+SIGTAB(1,59,I)
          IF(SIGMAX.GT.SIGGEN(4)) THEN
            ISIGM = I
            SIGGEN(4) = SIGMAX
          ENDIF
 160    CONTINUE
      ELSE
      WRITE(6,'(2(/1X,A))') 'ACTIVATED PROCESSES, CROSS SECTION:',
     &                      '==================================='
      WRITE(6,'(5X,A,I3)') '  NONDIFFR. RESOLVED PROCESSES',IPRON(1)
      WRITE(6,'(5X,A,I3)')  '            ELASTIC SCATTERING',IPRON(2)
      WRITE(6,'(5X,A,I3)')  'QELAST. VECTORMESON PRODUCTION',IPRON(3)
      WRITE(6,'(5X,A,I3)')  '      DOUBLE POMERON PROCESSES',IPRON(4)
      WRITE(6,'(5X,A,I3)')  ' SINGLE DIFFRACT. PARTICLE (1)',IPRON(5)
      WRITE(6,'(5X,A,I3)')  ' SINGLE DIFFRACT. PARTICLE (2)',IPRON(6)
      WRITE(6,'(5X,A,I3)')  '    DOUBLE DIFFRACT. PROCESSES',IPRON(7)
      WRITE(6,'(5X,A,I3)')  '       DIRECT PHOTON PROCESSES',IPRON(8)
      WRITE(6,'(5X,A,I3)')  '  HARD DIFF-DISS. PARTICLE (1)',IPRON(9)
      WRITE(6,'(5X,A,I3)')  '  HARD DIFF-DISS. PARTICLE (2)',IPRON(10)
      WRITE(6,'(5X,A,I3)')  '  HARD DOUBLE POMERON SCATTER.',IPRON(11)
C  calculate effective cross section
      SIGGEN(4) = 0.D0
      DO 165 I=1,IEEMAX
        SIGMAX = 0.D0
        SIGTOT     =  SIGTAB(1,1,I)
        SIGELA     =  SIGTAB(1,2,I)
        SIGVM(0,0) = SIGTAB(1,3,I)
        SIGDIR     = SIGTAB(1,29,I)
        SIGLSD(1)  = SIGTAB(1,30,I)
        SIGLSD(2)  = SIGTAB(1,31,I)
        SIGHSD(1)  = SIGTAB(1,32,I)
        SIGHSD(2)  = SIGTAB(1,33,I)
        SIGLDD     = SIGTAB(1,34,I)
        SIGHDD     = SIGTAB(1,35,I)
        SIGCDF     = SIGTAB(1,36,I)
        IF(IPRON(1).EQ.1) SIGMAX = SIGTOT-SIGELA-SIGVM(0,0)-SIGCDF
     &  -SIGLSD(1)-SIGHSD(1)-SIGLSD(2)-SIGHSD(2)-SIGLDD-SIGHDD-SIGDIR
        IF(IPRON(2).EQ.1) SIGMAX = SIGMAX+SIGELA
        IF(IPRON(3).EQ.1) SIGMAX = SIGMAX+SIGVM(0,0)
        IF(IPRON(4).EQ.1) SIGMAX = SIGMAX+SIGCDF
        IF(IPRON(5).EQ.1) SIGMAX = SIGMAX+SIGLSD(1)+SIGHSD(1)
        IF(IPRON(6).EQ.1) SIGMAX = SIGMAX+SIGLSD(2)+SIGHSD(2)
        IF(IPRON(7).EQ.1) SIGMAX = SIGMAX+SIGLDD+SIGHDD
        IF(IPRON(8).EQ.1) SIGMAX = SIGMAX+SIGDIR
        IF(SIGMAX.GT.SIGGEN(4)) THEN
          ISIGM = I
          SIGGEN(4) = SIGMAX
        ENDIF
 165  CONTINUE
      ENDIF
      IF(SIGGEN(4).LT.1.D-20) THEN
        WRITE(6,'(//1X,A)') 
     &  'POMCIN:ERROR:SELECTED PROCESSES HAVE VANISHING X-SECTION'
        STOP
      ENDIF
      WRITE(6,'(3X,A,1P3E11.4)') 
     &  'MAXIMUM SEARCH (EMIN/EMAX/EPEAK)',SIGECM(1,1),
     &  SIGECM(1,IEEMAX),SIGECM(1,ISIGM)
      WRITE(6,'(11X,A,1PE12.4,/)') 'MAX. CROSS SECTION (mb)',SIGGEN(4)
      END
