C
C
      SUBROUTINE QUASTA(IFL,IDPDG,IMODE)
C**********************************************************************
C
C     collect quark statistics
C     input:    IFL    parton flavour (PDG number)
C               IDPDG  mother particle (PDG number)
C               IMODE  1 .. 6   collect statistics
C                               (1,2,3,4 = valence,reggeon,sea,hard)
C                      -1       initialization
C                      -2       output
C
C**********************************************************************
      IMPLICIT DOUBLE PRECISION(A-H,O-Z)
      SAVE
C  global energy
      COMMON /GLOCMS/ ECM,PCM,PMASS(2),PVIRT(2),IFPAP(2),IFPAB(2)
C
      CHARACTER*7 PDGNAM
      CHARACTER*8 HADNAM,PANAME
      CHARACTER*16 SPLNAM
      DIMENSION ICPART(-23:23,22),HADNAM(4),SPLNAM(7),PDGNAM(-23:23)
      DATA PDGNAM / '-others','-(cc)_3', ' (cs)_1',' (cs)_0',
     &              ' (cu)_1',' (cu)_0', ' (cd)_1',' (cd)_0',
     &              ' (ss)_3',
     &              '-(su)_1','-(su)_0', '-(sd)_1','-(sd)_0',
     &              '-(uu)_1','-(ud)_1', '-(ud)_0','-(dd)_1',
     &              '  -t   ','  -b   ', '  -c   ','  -s   ',
     &              '  -u   ','  -d   ', '   g   ',
     &              '   d   ','   u   ', '   s   ','   c   ',
     &              '   b   ','   t   ', ' (dd)_1',' (ud)_0',
     &              ' (ud)_1',' (uu)_1', ' (sd)_0',' (sd)_1',
     &              ' (su)_0',' (su)_1', ' (ss)_3',
     &              ' (cd)_0',' (cd)_1', ' (cu)_0',' (cu)_1',
     &              ' (cs)_0',' (cs)_1', ' (cc)_3',' others' /
      DATA SPLNAM / 'VALENCE  PARTONS',
     &              'REGGEON  PARTONS',
     &              'SEA      PARTONS',
     &              'HARD INI PARTONS',
     &              'SPECTATORS / ISR',
     &              'HARD FIN PARTONS',
     &              'FINAL    PARTONS' /
C
      IF((IMODE.GT.0).AND.(IMODE.LT.8)) THEN
        IF(IMODE.LT.6) THEN
          IF(IDPDG.EQ.IFPAP(1)) THEN
            K = 1
          ELSE IF(IDPDG.EQ.IFPAP(2)) THEN
            K = 2
          ELSE IF(IDPDG.EQ.45) THEN
            K = 3
          ELSE
            K = 4
          ENDIF
          K = 4*(IMODE-1)+K
        ELSE
          K = 15+IMODE
        ENDIF
        IFLA = ABS(IFL)
        IF(IFLA.LE.6) THEN
          ICPART(IFL,K) = ICPART(IFL,K)+1
        ELSE IF((IFL.EQ.21).OR.(IFL.EQ.9)) THEN
          ICPART(0,K) = ICPART(0,K)+1
        ELSE
          INDX = 23
          IF(IFLA.EQ.1103) THEN
            INDX = 7
          ELSE IF(IFLA.EQ.2101) THEN
            INDX = 8
          ELSE IF(IFLA.EQ.2103) THEN
            INDX = 9
          ELSE IF(IFLA.EQ.2203) THEN
            INDX = 10
          ELSE IF(IFLA.EQ.3101) THEN
            INDX = 11
          ELSE IF(IFLA.EQ.3103) THEN
            INDX = 12
          ELSE IF(IFLA.EQ.3201) THEN
            INDX = 13
          ELSE IF(IFLA.EQ.3203) THEN
            INDX = 14
          ELSE IF(IFLA.EQ.3303) THEN
            INDX = 15
          ELSE IF(IFLA.EQ.4101) THEN
            INDX = 16
          ELSE IF(IFLA.EQ.4103) THEN
            INDX = 17
          ELSE IF(IFLA.EQ.4201) THEN
            INDX = 18
          ELSE IF(IFLA.EQ.4203) THEN
            INDX = 19
          ELSE IF(IFLA.EQ.4303) THEN
            INDX = 20
          ELSE IF(IFLA.EQ.4301) THEN
            INDX = 21
          ELSE IF(IFLA.EQ.4403) THEN
            INDX = 22
          ENDIF
          INDX = SIGN(INDX,IFL)
          ICPART(INDX,K) = ICPART(INDX,K)+1
        ENDIF
C  initialization
      ELSE IF(IMODE.EQ.-1) THEN
        DO 100 I=1,22
          DO 110 K=-23,23
            ICPART(K,I) = 0
 110      CONTINUE
 100    CONTINUE
        HADNAM(1) = PANAME(IFPAB(1),0)
        HADNAM(2) = PANAME(IFPAB(2),0)
        HADNAM(3) = PANAME(184,0)
        HADNAM(4) = 'OTHERS  '
C  output of statistics
      ELSE IF(IMODE.EQ.-2) THEN
        WRITE(6,'(2(/,1X,A))') 'QUASTA:QUARK STATISTICS:',
     &                         '======================='
        DO 200 I=1,5
          I1 = 4*(I-1)+1
          I2 = 4*(I-1)+4
          WRITE(6,'(1X,A16,8X,4(2X,A8))') SPLNAM(I),HADNAM
          DO 250 K=-23,23
            ISUM = 0
            DO 260 L=I1,I2
              ISUM = ISUM+ICPART(K,L)
 260        CONTINUE
            IF(ISUM.GT.0) WRITE(6,'(10X,A,2X,4I12)') PDGNAM(K),
     &        (ICPART(K,L),L=I1,I2)
 250      CONTINUE
 200    CONTINUE
        DO 300 I=6,7
          WRITE(6,'(1X,A16)') SPLNAM(I)
          L = 15+I
          DO 350 K=-23,23
            IF(ICPART(K,L).GT.0) WRITE(6,'(10X,A,2X,I12)') PDGNAM(K),
     &        ICPART(K,L)
 350      CONTINUE
 300    CONTINUE
      ELSE
        WRITE(6,'(/,1X,A,I3)') 'QUASTA:ERROR: UNSUPPORTED IMODE',IMODE
        CALL POABRT
      ENDIF
      END
