C
C
      SUBROUTINE SADSDT(IELA1,IELA2,TT)
C**********************************************************************
C
C     t sampling of elastic/quasi elastic processes
C
C     input:   IELA1,2   0   purely elastic scattering
C                        1   rho production
C                        2   omega production
C                        3   phi production
C                        4   pi+/pi- background
C              IELA1     -1  initialization
C                        -2  output of statistics
C
C     output:  TT     t   Mandelstam variable (negative)
C
C**********************************************************************
      IMPLICIT DOUBLE PRECISION(A-H,O-Z)
      SAVE
C
      PARAMETER(NTAB = 20,
     &          EPS  = 1.D-10,
     &          IONE = 1,
     &          ZERO = 0.D0)
C
      PARAMETER (NMAXD=100)
      COMMON /DEBUG/ IDEB(NMAXD),KSPOM,KHPOM,KSREG,KHDIR,KACCEP,
     &  KSTRG,KHTRG,KSLOO,KHLOO,KSDPO,KHDPO,KEVENT,KSOFT,KHARD
      CHARACTER*8 MDLNA
      COMMON /MODELS/ MDLNA(50),ISWMDL(50),PARMDL(200),IPAMDL(200)
C
      COMMON /XSECTP/ SIGTOT,SIGELA,SIGVM(0:4,0:4),SIGINE,SIGDIR,
     &                SIGLSD(2),SIGHSD(2),SIGLDD,SIGHDD,SIGCDF,
     &                SIGPOM,SIGREG,SIGHAR,SIGTR1,SIGTR2,SIGLOO,SIGDPO,
     &                SIG1SO,SIG1HA,SLOEL,SLOVM(4,4),SIGGEN(4),
     &                FSUP(2)
      COMMON /QEVECM/ VMAS(4),GAMM(4),RMIN(4),RMAX(4),VMSL(4),VMFA(4),
     &                TMIN(4),TMAX(4)
C
      IF(((IELA1.GE.0).AND.(IELA1.LE.4))
     &   .AND.((IELA2.GE.0).AND.(IELA2.LE.4))) THEN
C  determine slope
        IF(ISWMDL(13).EQ.0) THEN
C  external slope values
          print *,' SADSDT:ERROR:not installed !!!!!!!'
          CALL POABRT
        ELSE IF(ISWMDL(13).EQ.1) THEN
C  model slopes
          IF(IELA1*IELA2.EQ.0) THEN
            SLOPE = SLOEL
            TTMIN = TMIN(1)
            TTMAX = TMAX(1)
          ELSE
            SLOPE = SLOVM(IELA1,IELA2)
            I = MAX(IELA1,IELA2)
            TTMIN = TMIN(I)
            TTMAX = TMAX(I)
          ENDIF
        ELSE
          WRITE(6,'(/1X,A,I5)') 'SASDSDT:ERROR:INVALID ISWMDL(13)',
     &      ISWMDL(13)
          CALL POABRT
        ENDIF
C  sampling of t value
        XI0   = EXP(-SLOPE*ABS(TTMIN))
        XIDEL = EXP(-SLOPE*ABS(TTMAX))-XI0
        TT = LOG(XIDEL*RNDM(XI)+XI0)/SLOPE
C  debug output
        IF(IDEB(33).GE.15) WRITE(6,'(1X,A,2I3,2E12.3)')
     &    'SADSDT:DEBUG:IELA1,IELA2,SLOPE,T',IELA1,IELA2,SLOPE,TT
C  initialization of tables
      ELSE IF(IELA1.EQ.-1) THEN
C  output of statistics
      ELSE IF(IELA1.EQ.-2) THEN
C  unknown mode IELA1
      ELSE
        WRITE(6,'(/1X,A,2I5)') 'SADSDT:ERROR:UNSUPPORTED IELA1,IELA2',
     &    IELA1,IELA2
        CALL POABRT
      ENDIF
      END
