
      SUBROUTINE GRACHA

*#**********************************************************************
*#
*#    SUBROUTINE GRACHA
*#
*# PURPOSE: INTERPRET THE BOS TEXT BANK GRAP TO CHANGE THE DEFAULT
*#          PARAMETERS OF RAPGAP.
*#
*# INPUT: BOS TEXT BANK GRAP
*#
*# OUTPUT: UPDATED PARAMETERS IN RAPGAP COMMONS.
*#
*# CALLED BY: GRAPGA
*#
*# AUTHOR: HANNES JUNG              CREATED AT: 91/07/07
*#
*# CHANGED BY: Julian Phillips              AT: 96/10/01
*# REASON: Add parameter QSTART read in from WEQ2 steering card.
*#         Events are weighted with max(1.0,q2start/q2)
*#**********************************************************************
C JPP - Use H1 Software correctly
#include "h1mcutil/comdef/cbcs.inc"

      CHARACTER*4     CHAINT,PARAM
*
#include "rgpypars.inc"
#include "rgparas.inc"
#include "rgluco.inc"
#include "rgpart.inc"
#include "rgdiffr.inc"
#include "rgdisdif.inc"
#include "rgfull.inc"
#include "rgscq2.inc"
#include "rglq2.inc"
#include "pshwr.inc"
#include "rgprkt.inc"
#include "rgpqcdpom.inc"
#include "rgnlo.inc"
#include "rgpdiss.inc"
#include "rgherup.inc"
      INTEGER IGROUP1, ISET1,idif
	Common/strnew/IGROUP1,ISET1,idif
      COMMON/VMESON/IVM
      DOUBLE PRECISION C1,Cg
      COMMON/BUCHMUE/C1,Cg
      COMMON /COLCON/ ICOLORA,IRESPRO,IRPA,IRPB,IRPC,IRPD,IRPE,IRPF,IRPG
      REAL ACC1,ACC2
      COMMON /INTEGR/ ACC1,ACC2,IINT,NCB
      Integer IGLU
      Common/gluon/Iglu
C---Is there a text bank to be interpreted
      IND = NLINK('GRAP',0)
      IF (IND.LE.0) THEN
         PRINT *,' GRACHA: GRAP BANK NOT FOUND,',
     +           ' NO RAPGAP PARAMETERS CHANGED'
         RETURN
      ELSE
         PRINT *,' GRACHA: GRAP BANK EXISTS,',
     +           ' RAPGAP PARAMETERS MIGHT BE CHANGED'
      ENDIF

C---Determine the machine accuacy EPSMAC (D= 2.E-06)
      EPSMAC = 0.5
      DO 10 I= 1, 100
         EPSMAC = EPSMAC * 0.5
         IF ((1.0+EPSMAC) .EQ. 1.0) GO TO 20
   10 CONTINUE
      EPSMAC = 1.0E-6
   20 EPSMAC = 2.0 * EPSMAC
      WRITE(6,10000) EPSMAC
10000 FORMAT(1X,/,' COMPUTED MACHINE ACCURACY = ',G10.2,/)

C---Interpret the text bank containing the parameters to be changed
      IF (IW(IND).NE.0) THEN
         DO 30 ,I=IND+4,IND+IW(IND),4
C           WRITE(6,*) CHAINT(IW(I-3)),IW(I-2),IW(I-1)
C           WRITE(6,*) RW(I)
C           WRITE(6,*) IW(I)
C           WRITE(6,*) CHAINT(IW(I-1)), CHAINT(IW(I))

            PARAM = CHAINT(IW(I-3))
            LND = IW(I-2)
            LNE = IW(I-1)
            INT = IW(I)
            REA = RW(I)

            IF (PARAM.EQ.'LEPI') THEN
               IDEF = KE
               IF (ABS(IDEF-INT).GT.EPSMAC) THEN
                  KE = INT
                  PRINT 10100, PARAM,LND,IDEF,INT
               ELSE
                  PRINT 10200, PARAM,LND,IDEF,INT
               ENDIF
            ENDIF
            IF (PARAM.EQ.'HADI') THEN
               IDEF = KP
               IF (ABS(IDEF-INT).GT.EPSMAC) THEN
                  KP = INT
                  PRINT 10100, PARAM,LND,IDEF,INT
               ELSE
                  PRINT 10200, PARAM,LND,IDEF,INT
               ENDIF
            ENDIF

            IF (PARAM.EQ.'NFRA') THEN
               IDEF = NFRAG
               IF (ABS(IDEF-INT).GT.EPSMAC) THEN
                  NFRAG = INT
                  PRINT 10100, PARAM,LND,IDEF,INT
               ELSE
                  PRINT 10200, PARAM,LND,IDEF,INT
               ENDIF
            ENDIF
            IF (PARAM.EQ.'IFPS') THEN
               IDEF = IFPS
               IF (ABS(IDEF-INT).GT.EPSMAC) THEN
                  IFPS = INT
                  PRINT 10100, PARAM,LND,IDEF,INT
               ELSE
                  PRINT 10200, PARAM,LND,IDEF,INT
               ENDIF
            ENDIF
            IF (PARAM.EQ.'IPST') THEN
               IDEF = IPST
               IF (ABS(IDEF-INT).GT.EPSMAC) THEN
                  IPST = INT
                  PRINT 10100, PARAM,LND,IDEF,INT
               ELSE
                  PRINT 10200, PARAM,LND,IDEF,INT
               ENDIF
            ENDIF
            IF (PARAM.EQ.'IRAS') THEN
               IDEF = IRUNA
               IF (ABS(IDEF-INT).GT.EPSMAC) THEN
                  IRUNA = INT
                  PRINT 10100, PARAM,LND,IDEF,INT
               ELSE
                  PRINT 10200, PARAM,LND,IDEF,INT
               ENDIF
            ENDIF
            IF (PARAM.EQ.'IRAM') THEN
               IDEF = IRUNAEM
               IF (ABS(IDEF-INT).GT.EPSMAC) THEN
                  IRUNAEM = INT
                  PRINT 10100, PARAM,LND,IDEF,INT
               ELSE
                  PRINT 10200, PARAM,LND,IDEF,INT
               ENDIF
            ENDIF
            IF (PARAM.EQ.'IQ2S') THEN
               IDEF = IQ2
               IF (ABS(IDEF-INT).GT.EPSMAC) THEN
                  IQ2 = INT
                  PRINT 10100, PARAM,LND,IDEF,INT
               ELSE
                  PRINT 10200, PARAM,LND,IDEF,INT
               ENDIF
            ENDIF
            IF (PARAM.EQ.'IPRO') THEN
               IDEF = IPRO
               IF (ABS(IDEF-INT).GT.EPSMAC) THEN
                  IPRO = INT
                  PRINT 10100, PARAM,LND,IDEF,INT
               ELSE
                  PRINT 10200, PARAM,LND,IDEF,INT
               ENDIF
            ENDIF
            IF (PARAM.EQ.'INGG') THEN
               IDEF = NG
               IF (ABS(IDEF-INT).GT.EPSMAC) THEN
                  NG = INT
                  PRINT 10100, PARAM,LND,IDEF,INT
               ELSE
                  PRINT 10200, PARAM,LND,IDEF,INT
               ENDIF
            ENDIF
            IF (PARAM.EQ.'INPR') THEN
               IDEF = MSTP(51)
               IF (ABS(IDEF-INT).GT.EPSMAC) THEN
                  MSTP(51) = INT
                  PRINT 10100, PARAM,LND,IDEF,INT
               ELSE
                  PRINT 10200, PARAM,LND,IDEF,INT
               ENDIF
            ENDIF
            IF (PARAM.EQ.'INPI') THEN
               IDEF = MSTP(52)
               IF (ABS(IDEF-INT).GT.EPSMAC) THEN
                  MSTP(52) = INT
                  PRINT 10100, PARAM,LND,IDEF,INT
               ELSE
                  PRINT 10200, PARAM,LND,IDEF,INT
               ENDIF
            ENDIF
            IF (PARAM.EQ.'INGA') THEN
               IDEF = MSTP(56)
               IF (ABS(IDEF-INT).GT.EPSMAC) THEN
                  MSTP(56) = INT
                  PRINT 10100, PARAM,LND,IDEF,INT
               ELSE
                  PRINT 10200, PARAM,LND,IDEF,INT
               ENDIF
            ENDIF
            IF (PARAM.EQ.'IDIR') THEN
               IDEF = IDIR
               IF (ABS(IDEF-INT).GT.EPSMAC) THEN
                  IDIR = INT
                  PRINT 10100, PARAM,LND,IDEF,INT
               ELSE
                  PRINT 10200, PARAM,LND,IDEF,INT
               ENDIF
            ENDIF
            IF (PARAM.EQ.'IAKT') THEN
               IDEF = IALMKT
               IF (ABS(IDEF-INT).GT.EPSMAC) THEN
                  IALMKT = INT
                  PRINT 10100, PARAM,LND,IDEF,INT
               ELSE
                  PRINT 10200, PARAM,LND,IDEF,INT
               ENDIF
            ENDIF
            IF (PARAM.EQ.'IDIF') THEN
               IDEF = IDISDIF
               IF (ABS(IDEF-INT).GT.EPSMAC) THEN
                  IDISDIF = INT
                  PRINT 10100, PARAM,LND,IDEF,INT
               ELSE
                  PRINT 10200, PARAM,LND,IDEF,INT
               ENDIF
            ENDIF
            IF (PARAM.EQ.'IFUL') THEN
               IDEF = IFULL
               IF (ABS(IDEF-INT).GT.EPSMAC) THEN
                  IFULL = INT
                  PRINT 10100, PARAM,LND,IDEF,INT
               ELSE
                  PRINT 10200, PARAM,LND,IDEF,INT
               ENDIF
            ENDIF
            IF (PARAM.EQ.'IGRI') THEN
               IDEF = IQCDGRID
               IF (ABS(IDEF-INT).GT.EPSMAC) THEN
                  IQCDGRID = INT
                  PRINT 10100, PARAM,LND,IDEF,INT
               ELSE
                  PRINT 10200, PARAM,LND,IDEF,INT
               ENDIF
            ENDIF
            IF (PARAM.EQ.'IPOM') THEN
               IDEF = NPOM
               IF (ABS(IDEF-INT).GT.EPSMAC) THEN
                  NPOM = INT
                  PRINT 10100, PARAM,LND,IDEF,INT
               ELSE
                  PRINT 10200, PARAM,LND,IDEF,INT
               ENDIF
            ENDIF
            IF (PARAM.EQ.'IVME') THEN
               IDEF = IVM
               IF (ABS(IDEF-INT).GT.EPSMAC) THEN
                  IVM = INT
                  PRINT 10100, PARAM,LND,IDEF,INT
               ELSE
                  PRINT 10200, PARAM,LND,IDEF,INT
               ENDIF
            ENDIF
            IF (PARAM.EQ.'IREM') THEN
               IDEF = IREM
               IF (ABS(IDEF-INT).GT.EPSMAC) THEN
                  IREM = INT
                  PRINT 10100, PARAM,LND,IDEF,INT
               ELSE
                  PRINT 10200, PARAM,LND,IDEF,INT
               ENDIF
            ENDIF

            IF (PARAM.EQ.'NFLA') THEN
               IDEF = NFLAV
               IF (ABS(IDEF-INT).GT.EPSMAC) THEN
                  NFLAV = INT
                  PRINT 10100, PARAM,LND,IDEF,INT
               ELSE
                  PRINT 10200, PARAM,LND,IDEF,INT
               ENDIF
            ENDIF
            IF (PARAM.EQ.'NFQC') THEN
               IDEF = NFLQCDC
               IF (ABS(IDEF-INT).GT.EPSMAC) THEN
                  NFLQCDC = INT
                  PRINT 10100, PARAM,LND,IDEF,INT
               ELSE
                  PRINT 10200, PARAM,LND,IDEF,INT
               ENDIF
            ENDIF

            IF (PARAM.EQ.'INTE') THEN
               IDEF = INTER
               IF (ABS(IDEF-INT).GT.EPSMAC) THEN
                  INTER = INT
                  PRINT 10100, PARAM,LND,IDEF,INT
               ELSE
                  PRINT 10200, PARAM,LND,IDEF,INT
               ENDIF
            ENDIF

            IF (PARAM.EQ.'IHFL') THEN
               IDEF = IHFLA
               IF (ABS(IDEF-INT).GT.EPSMAC) THEN
                  IHFLA = INT
                  PRINT 10100, PARAM,LND,IDEF,INT
               ELSE
                  PRINT 10200, PARAM,LND,IDEF,INT
               ENDIF
            ENDIF

            IF (PARAM.EQ.'IRPA') THEN
               IDEF = IRPA
               IF (ABS(IDEF-INT).GT.EPSMAC) THEN
                  IRPA = INT
                  PRINT 10100, PARAM,LND,IDEF,INT
               ELSE
                  PRINT 10200, PARAM,LND,IDEF,INT
               ENDIF
            ENDIF
            IF (PARAM.EQ.'IRPB') THEN
               IDEF = IRPB
               IF (ABS(IDEF-INT).GT.EPSMAC) THEN
                  IRPB = INT
                  PRINT 10100, PARAM,LND,IDEF,INT
               ELSE
                  PRINT 10200, PARAM,LND,IDEF,INT
               ENDIF
            ENDIF
            IF (PARAM.EQ.'IRPC') THEN
               IDEF = IRPC
               IF (ABS(IDEF-INT).GT.EPSMAC) THEN
                  IRPC = INT
                  PRINT 10100, PARAM,LND,IDEF,INT
               ELSE
                  PRINT 10200, PARAM,LND,IDEF,INT
               ENDIF
            ENDIF
            IF (PARAM.EQ.'IRPD') THEN
               IDEF = IRPD
               IF (ABS(IDEF-INT).GT.EPSMAC) THEN
                  IRPD = INT
                  PRINT 10100, PARAM,LND,IDEF,INT
               ELSE
                  PRINT 10200, PARAM,LND,IDEF,INT
               ENDIF
            ENDIF
            IF (PARAM.EQ.'IRPE') THEN
               IDEF = IRPE
               IF (ABS(IDEF-INT).GT.EPSMAC) THEN
                  IRPE = INT
                  PRINT 10100, PARAM,LND,IDEF,INT
               ELSE
                  PRINT 10200, PARAM,LND,IDEF,INT
               ENDIF
            ENDIF
            IF (PARAM.EQ.'IRPF') THEN
               IDEF = IRPF
               IF (ABS(IDEF-INT).GT.EPSMAC) THEN
                  IRPF = INT
                  PRINT 10100, PARAM,LND,IDEF,INT
               ELSE
                  PRINT 10200, PARAM,LND,IDEF,INT
               ENDIF
            ENDIF
            IF (PARAM.EQ.'IRPG') THEN
               IDEF = IRPG
               IF (ABS(IDEF-INT).GT.EPSMAC) THEN
                  IRPG = INT
                  PRINT 10100, PARAM,LND,IDEF,INT
               ELSE
                  PRINT 10200, PARAM,LND,IDEF,INT
               ENDIF
            ENDIF

            IF (PARAM.EQ.'ISET') THEN
               IDEF = ISET
               IF (ABS(IDEF-INT).GT.EPSMAC) THEN
                  ISET = INT
                  PRINT 10100, PARAM,LND,IDEF,INT
               ELSE
                  PRINT 10200, PARAM,LND,IDEF,INT
               ENDIF
            ENDIF
            IF (PARAM.EQ.'IP2 ') THEN
               IDEF = IP2
               IF (ABS(IDEF-INT).GT.EPSMAC) THEN
                  IP2 = INT
                  PRINT 10100, PARAM,LND,IDEF,INT
               ELSE
                  PRINT 10200, PARAM,LND,IDEF,INT
               ENDIF
            ENDIF

            IF (PARAM.EQ.'ISEH') THEN
               IDEF = ISEMIH
               IF (ABS(IDEF-INT).GT.EPSMAC) THEN
                  ISEMIH = INT
                  PRINT 10100, PARAM,LND,IDEF,INT
               ELSE
                  PRINT 10200, PARAM,LND,IDEF,INT
               ENDIF
            ENDIF
            IF (PARAM.EQ.'IORD') THEN
               IDEF = IORDER
               IF (ABS(IDEF-INT).GT.EPSMAC) THEN
                  IORDER = INT
                  PRINT 10100, PARAM,LND,IDEF,INT
               ELSE
                  PRINT 10200, PARAM,LND,IDEF,INT
               ENDIF
            ENDIF
            IF (PARAM.EQ.'ICCF') THEN
               IDEF = ICCFM
               IF (ABS(IDEF-INT).GT.EPSMAC) THEN
                  ICCFM = INT
                  PRINT 10100, PARAM,LND,IDEF,INT
               ELSE
                  PRINT 10200, PARAM,LND,IDEF,INT
               ENDIF
            ENDIF
            IF (PARAM.EQ.'IALP') THEN
               IDEF = IALPS
               IF (ABS(IDEF-INT).GT.EPSMAC) THEN
                  IALPS = INT
                  PRINT 10100, PARAM,LND,IDEF,INT
               ELSE
                  PRINT 10200, PARAM,LND,IDEF,INT
               ENDIF
            ENDIF
            IF (PARAM.EQ.'ITIM') THEN
               IDEF = ITIMSHR
               IF (ABS(IDEF-INT).GT.EPSMAC) THEN
                  ITIMSHR = INT
                  PRINT 10100, PARAM,LND,IDEF,INT
               ELSE
                  PRINT 10200, PARAM,LND,IDEF,INT
               ENDIF
            ENDIF
            IF (PARAM.EQ.'ISOG') THEN
               IDEF = ISOFTG
               IF (ABS(IDEF-INT).GT.EPSMAC) THEN
                  ISOFTG = INT
                  PRINT 10100, PARAM,LND,IDEF,INT
               ELSE
                  PRINT 10200, PARAM,LND,IDEF,INT
               ENDIF
            ENDIF
            IF (PARAM.EQ.'IINT') THEN
               IDEF= IINT
               IF (ABS(IDEF-INT).GT.EPSMAC) THEN
                  IINT = INT
                  PRINT 10100, PARAM,LND,IDEF,INT
               ELSE
                  PRINT 10200, PARAM,LND,IDEF,INT
               ENDIF
            ENDIF
            IF (PARAM.EQ.'NCAL') THEN
               IDEF= NCB
               IF (ABS(IDEF-INT).GT.EPSMAC) THEN
                  NCB = INT
                  PRINT 10100, PARAM,LND,IDEF,INT
               ELSE
                  PRINT 10200, PARAM,LND,IDEF,INT
               ENDIF
            ENDIF
            IF (PARAM.EQ.'IRSP') THEN
               IDEF= IRspl
               IF (ABS(IDEF-INT).GT.EPSMAC) THEN
                  IRspl = INT
                  PRINT 10100, PARAM,LND,IDEF,INT
               ELSE
                  PRINT 10200, PARAM,LND,IDEF,INT
               ENDIF
            ENDIF
            IF (PARAM.EQ.'Iqqg') THEN
               IDEF= Iqqg
               IF (ABS(IDEF-INT).GT.EPSMAC) THEN
                  Iqqg = INT
                  PRINT 10100, PARAM,LND,IDEF,INT
               ELSE
                  PRINT 10200, PARAM,LND,IDEF,INT
               ENDIF
            ENDIF
            IF (PARAM.EQ.'Igkt') THEN
               IDEF= Igamkt
               IF (ABS(IDEF-INT).GT.EPSMAC) THEN
                  Igamkt = INT
                  PRINT 10100, PARAM,LND,IDEF,INT
               ELSE
                  PRINT 10200, PARAM,LND,IDEF,INT
               ENDIF
            ENDIF
            IF (PARAM.EQ.'IGLU') THEN
               IDEF = IGLU
               IF (ABS(IDEF-INT).GT.EPSMAC) THEN
                  IGLU = INT
                  PRINT 10100, PARAM,LND,IDEF,INT
               ELSE
                  PRINT 10200, PARAM,LND,IDEF,INT
               ENDIF
            ENDIF
            IF (PARAM.EQ.'IBS ') THEN
               IDEF = IBS
               IF (ABS(IDEF-INT).GT.EPSMAC) THEN
                  IBS = INT
                  PRINT 10100, PARAM,LND,IDEF,INT
               ELSE
                  PRINT 10200, PARAM,LND,IDEF,INT
               ENDIF
            ENDIF
            IF (PARAM.EQ.'IJET') THEN
               IDEF = ijetset
               IF (ABS(IDEF-INT).GT.EPSMAC) THEN
                  ijetset = INT
                  PRINT 10100, PARAM,LND,IDEF,INT
               ELSE
                  PRINT 10200, PARAM,LND,IDEF,INT
               ENDIF
            ENDIF
            IF (PARAM.EQ.'IFRP') THEN
               IDEF = ifragp
               IF (ABS(IDEF-INT).GT.EPSMAC) THEN
                  ifragp = INT
                  PRINT 10100, PARAM,LND,IDEF,INT
               ELSE
                  PRINT 10200, PARAM,LND,IDEF,INT
               ENDIF
            ENDIF
            IF (PARAM.EQ.'IRGL') THEN
               IDEF = i_glu
               IF (ABS(IDEF-INT).GT.EPSMAC) THEN
                  i_glu = INT
                  PRINT 10100, PARAM,LND,IDEF,INT
               ELSE
                  PRINT 10200, PARAM,LND,IDEF,INT
               ENDIF
            ENDIF
            IF (PARAM.EQ.'ILHA') THEN
               IDEF = ILHE
               IF (ABS(IDEF-INT).GT.EPSMAC) THEN
                  ILHA = INT
                  PRINT 10100, PARAM,LND,IDEF,INT
               ELSE
                  PRINT 10200, PARAM,LND,IDEF,INT
               ENDIF
            ENDIF
            IF (PARAM.EQ.'IGR ') THEN
               IDEF = IGROUP1
               IF (ABS(IDEF-INT).GT.EPSMAC) THEN
                  IGROUP1 = INT
                  PRINT 10100, PARAM,LND,IDEF,INT
               ELSE
                  PRINT 10200, PARAM,LND,IDEF,INT
               ENDIF
            ENDIF
            IF (PARAM.EQ.'ISE ') THEN
               IDEF = ISET1
               IF (ABS(IDEF-INT).GT.EPSMAC) THEN
                  ISET1 = INT
                  PRINT 10100, PARAM,LND,IDEF,INT
               ELSE
                  PRINT 10200, PARAM,LND,IDEF,INT
               ENDIF
            ENDIF

            IF (PARAM.EQ.'PPIN') THEN
               RDEF = PPIN
               IF (ABS(RDEF-REA).GT.EPSMAC) THEN
                  PPIN = REA
                  PRINT 10300, PARAM,LND,RDEF,REA
               ELSE
                  PRINT 10400, PARAM,LND,RDEF,REA
               ENDIF
            ENDIF
            IF (PARAM.EQ.'PLEP') THEN
               RDEF = PLEPIN
               IF (ABS(RDEF-REA).GT.EPSMAC) THEN
                  PLEPIN = REA
                  PRINT 10300, PARAM,LND,RDEF,REA
               ELSE
                  PRINT 10400, PARAM,LND,RDEF,REA
               ENDIF
            ENDIF
            IF (PARAM.EQ.'RRN2') THEN
               RDEF = SNGL(RN2)
               IF (ABS(RDEF-REA).GT.EPSMAC) THEN
                  RN2 = DBLE(REA)
                  PRINT 10300, PARAM,LND,RDEF,REA
               ELSE
                  PRINT 10400, PARAM,LND,RDEF,REA
               ENDIF
            ENDIF
            IF (PARAM.EQ.'EESP') THEN
               RDEF = SNGL(EPSP)
               IF (ABS(RDEF-REA).GT.EPSMAC) THEN
                  EPSP = DBLE(REA)
                  PRINT 10300, PARAM,LND,RDEF,REA
               ELSE
                  PRINT 10400, PARAM,LND,RDEF,REA
               ENDIF
            ENDIF
            IF (PARAM.EQ.'QMIN') THEN
               RDEF = SNGL(QMI)
               IF (ABS(RDEF-REA).GT.EPSMAC) THEN
                  QMI = DBLE(REA)
                  PRINT 10300, PARAM,LND,RDEF,REA
               ELSE
                  PRINT 10400, PARAM,LND,RDEF,REA
               ENDIF
            ENDIF
            IF (PARAM.EQ.'QMAX') THEN
               RDEF = SNGL(QMA)
               IF (ABS(RDEF-REA).GT.EPSMAC) THEN
                  QMA = DBLE(REA)
                  PRINT 10300, PARAM,LND,RDEF,REA
               ELSE
                  PRINT 10400, PARAM,LND,RDEF,REA
               ENDIF
            ENDIF
            IF (PARAM.EQ.'YMIN') THEN
               RDEF = SNGL(YMI)
               IF (ABS(RDEF-REA).GT.EPSMAC) THEN
                  YMI = DBLE(REA)
                  PRINT 10300, PARAM,LND,RDEF,REA
               ELSE
                  PRINT 10400, PARAM,LND,RDEF,REA
               ENDIF
            ENDIF
            IF (PARAM.EQ.'YMAX') THEN
               RDEF = SNGL(YMA)
               IF (ABS(RDEF-REA).GT.EPSMAC) THEN
                  YMA = DBLE(REA)
                  PRINT 10300, PARAM,LND,RDEF,REA
               ELSE
                  PRINT 10400, PARAM,LND,RDEF,REA
               ENDIF
            ENDIF
            IF (PARAM.EQ.'RALP') THEN
               RDEF = SNGL(ALPHP)
               IF (ABS(RDEF-REA).GT.EPSMAC) THEN
                  ALPHP = DBLE(REA)
                  PRINT 10300, PARAM,LND,RDEF,REA
               ELSE
                  PRINT 10400, PARAM,LND,RDEF,REA
               ENDIF
            ENDIF
            IF (PARAM.EQ.'RRXF') THEN
               RDEF = SNGL(XF)
               IF (ABS(RDEF-REA).GT.EPSMAC) THEN
                  XF = DBLE(REA)
                  PRINT 10300, PARAM,LND,RDEF,REA
               ELSE
                  PRINT 10400, PARAM,LND,RDEF,REA
               ENDIF
            ENDIF
            IF (PARAM.EQ.'RT2M') THEN
               RDEF = SNGL(T2MAX)
               IF (ABS(RDEF-REA).GT.EPSMAC) THEN
                  T2MAX = DBLE(REA)
                  PRINT 10300, PARAM,LND,RDEF,REA
               ELSE
                  PRINT 10400, PARAM,LND,RDEF,REA
               ENDIF
            ENDIF
            IF (PARAM.EQ.'PTCU') THEN
               IPROF = IPRO
               IF(IPRO.EQ.12.OR.IPRO.EQ.1200) THEN
                  PT2CUT(10) = DBLE(REA)
                  PT2CUT(13) = DBLE(REA)
                  PT2CUT(15) = DBLE(REA)
                  PT2CUT(18) = DBLE(REA)
               ELSE
                  IF(IPRO.GT.1000) IPROF = IPRO/1000
                  IF(IPRO.EQ.14.OR.IPRO.EQ.11) THEN
                     PT2CUT(IPROF) = 0.D0
                  ELSE
                     RDEF = SNGL(PT2CUT(IPROF))
                     IF (ABS(RDEF-REA).GT.EPSMAC) THEN
                        PT2CUT(IPROF) = DBLE(REA)
                        PRINT 10300, PARAM,LND,RDEF,REA
                     ELSE
                        PRINT 10400, PARAM,LND,RDEF,REA
                     ENDIF
                  ENDIF
               ENDIF
            ENDIF
            IF (PARAM.EQ.'THEM') THEN
               RDEF = SNGL(THEMA)
               IF (ABS(RDEF-REA).GT.EPSMAC) THEN
                  THEMA = DBLE(REA)
                  PRINT 10300, PARAM,LND,RDEF,REA
               ELSE
                  PRINT 10400, PARAM,LND,RDEF,REA
               ENDIF
            ENDIF
            IF (PARAM.EQ.'THEI') THEN
               RDEF = SNGL(THEMI)
               IF (ABS(RDEF-REA).GT.EPSMAC) THEN
                  THEMI = DBLE(REA)
                  PRINT 10300, PARAM,LND,RDEF,REA
               ELSE
                  PRINT 10400, PARAM,LND,RDEF,REA
               ENDIF
            ENDIF

            IF (PARAM.EQ.'WEQ2') THEN
               Q2START = 0.D0
               Q2 = DBLE(REA)
               IF(Q2.GT.0.1D0) THEN
                  Q2START=Q2
                  WRITE(6,*)' GRACHA: Weighting below Q2=',Q2START
               ENDIF
            ENDIF

            IF (PARAM.EQ.'OMEG') THEN
               RDEF = SNGL(OMEG2)
               IF (ABS(RDEF-REA).GT.EPSMAC) THEN
                  OMEG2 = DBLE(REA)
                  PRINT 10300, PARAM,LND,RDEF,REA
               ELSE
                  PRINT 10400, PARAM,LND,RDEF,REA
               ENDIF
            ENDIF

            IF (PARAM.EQ.'SCQ2') THEN
               RDEF = SNGL(SCALQ2)
               IF (ABS(RDEF-REA).GT.EPSMAC) THEN
                  SCALQ2 = DBLE(REA)
                  PRINT 10300, PARAM,LND,RDEF,REA
               ELSE
                  PRINT 10400, PARAM,LND,RDEF,REA
               ENDIF
            ENDIF

            IF (PARAM.EQ.'LQ2S') THEN
               RDEF = SNGL(Q2SUPP)
               IF (ABS(RDEF-REA).GT.EPSMAC) THEN
                  Q2SUPP = DBLE(REA)
                  PRINT 10300, PARAM,LND,RDEF,REA
               ELSE
                  PRINT 10400, PARAM,LND,RDEF,REA
               ENDIF
            ENDIF
            IF (PARAM.EQ.'KT1 ') THEN
               RDEF = SNGL(PRKT1)
               IF (ABS(RDEF-REA).GT.EPSMAC) THEN
                  PRKT1 = DBLE(REA)
                  PRINT 10300, PARAM,LND,RDEF,REA
               ELSE
                  PRINT 10400, PARAM,LND,RDEF,REA
               ENDIF
            ENDIF
            IF (PARAM.EQ.'KTM ') THEN
               RDEF = SNGL(PKTM)
               IF (ABS(RDEF-REA).GT.EPSMAC) THEN
                  PKTM = DBLE(REA)
                  PRINT 10300, PARAM,LND,RDEF,REA
               ELSE
                  PRINT 10400, PARAM,LND,RDEF,REA
               ENDIF
            ENDIF
            IF (PARAM.EQ.'KT2 ') THEN
               RDEF = SNGL(PRKT2)
               IF (ABS(RDEF-REA).GT.EPSMAC) THEN
                  PRKT2 = DBLE(REA)
                  PRINT 10300, PARAM,LND,RDEF,REA
               ELSE
                  PRINT 10400, PARAM,LND,RDEF,REA
               ENDIF
            ENDIF
            IF (PARAM.EQ.'SCAL') THEN
               RDEF = SNGL(SCALFA)
               IF (ABS(RDEF-REA).GT.EPSMAC) THEN
                  SCALFA = DBLE(REA)
                  PRINT 10300, PARAM,LND,RDEF,REA
               ELSE
                  PRINT 10400, PARAM,LND,RDEF,REA
               ENDIF
            ENDIF
            IF (PARAM.EQ.'C1  ') THEN
               RDEF = SNGL(C1)
               IF (ABS(RDEF-REA).GT.EPSMAC) THEN
                  C1 = DBLE(REA)
                  PRINT 10300, PARAM,LND,RDEF,REA
               ELSE
                  PRINT 10400, PARAM,LND,RDEF,REA
               ENDIF
            ENDIF
            IF (PARAM.EQ.'Cg  ') THEN
               RDEF = SNGL(Cg)
               IF (ABS(RDEF-REA).GT.EPSMAC) THEN
                  Cg = DBLE(REA)
                  PRINT 10300, PARAM,LND,RDEF,REA
               ELSE
                  PRINT 10400, PARAM,LND,RDEF,REA
               ENDIF
            ENDIF
            IF (PARAM.EQ.'ACC1') THEN
               RDEF = ACC1
               IF (ABS(RDEF-REA).GT.EPSMAC) THEN
                  ACC1 = REA
                  PRINT 10300, PARAM,LND,RDEF,REA
               ELSE
                  PRINT 10400, PARAM,LND,RDEF,REA
               ENDIF
            ENDIF
            IF (PARAM.EQ.'ACC2') THEN
               RDEF = ACC2
               IF (ABS(RDEF-REA).GT.EPSMAC) THEN
                  ACC2 = REA
                  PRINT 10300, PARAM,LND,RDEF,REA
               ELSE
                  PRINT 10400, PARAM,LND,RDEF,REA
               ENDIF
            ENDIF
            IF (PARAM.EQ.'PEPS') THEN
               RDEF = peps
               IF (ABS(RDEF-REA).GT.EPSMAC) THEN
                  peps = REA
                  PRINT 10300, PARAM,LND,RDEF,REA
               ELSE
                  PRINT 10400, PARAM,LND,RDEF,REA
               ENDIF
            ENDIF
            IF (PARAM.EQ.'PRN2') THEN
               RDEF = prn2
               IF (ABS(RDEF-REA).GT.EPSMAC) THEN
                  prn2 = REA
                  PRINT 10300, PARAM,LND,RDEF,REA
               ELSE
                  PRINT 10400, PARAM,LND,RDEF,REA
               ENDIF
            ENDIF

   30    CONTINUE
      ENDIF

10100 FORMAT(' GRACHA:',A4,'(',I4,')',
     +       ' CHANGED FROM THE DEFAULT ',I8,' TO',I8)
10200 FORMAT(' GRACHA (WARNING):',A4,'(',I4,')',
     +       ' NOT CHANGED FROM THE DEFAULT ',I8,' TO',I8)
10300 FORMAT(' GRACHA:',A4,'(',I4,')',
     +       ' CHANGED FROM THE DEFAULT ',E10.3,' TO',E10.3)
10400 FORMAT(' GRACHA (WARNING):',A4,'(',I4,')',
     +       ' NOT CHANGED FROM THE DEFAULT ',E10.3,' TO',E10.3)

10500 FORMAT(' GRACHA:',A4,'(',I4,',',I4,')',
     +       ' CHANGED FROM THE DEFAULT ',I8,' TO',I8)
10600 FORMAT(' GRACHA (WARNING):',A4,'(',I4,',',I4,')',
     +       ' NOT CHANGED FROM THE DEFAULT ',I8,' TO',I8)
10700 FORMAT(' GRACHA:',
     +       A4,' CHANGED FROM DEFAULT: ',A4,A4)
10800 FORMAT ('                   TO: ',A4,A4)

      RETURN
      END
