

      SUBROUTINE GRAEND

*#**********************************************************************
*#
*#    SUBROUTINE GRAEND
*#
*# PURPOSE: fill the cross section(s) corresponding to the generated
*#          events into the common for GENOUT. The final routine to be
*#          called and modified by the user is GUEND.
*#
*# CALLED BY:
*#
*# AUTHOR: Guenter Grindhammer              CREATED AT: 91/05/27
*#
*# CHANGED BY: H. JUNG                              AT:94/01/11
*# REASON: UPDATED FOR RAPGAP
*# CHANGED BY:                                      AT:
*# REASON:
*#
*#**********************************************************************

C---RAPGAP COMMONS
#include "rgeffic.inc"
#include "rgparas.inc"
#include "rgdisdif.inc"
      COMMON /QCDEV/ NQPM,NQQB,NQQBC,NQQBB,NQCDC
      COMMON/NEVOUT/NDIS,NQPMDS,NQQBDS,NQQBCDS,NQQBBDS,NQCDCDS,
     +              NDIF,NQPMDF,NQQBDF,NQQBCDF,NQQBBDF,NQCDCDF,
     +              NPI,NQPMPI,NQQBPI,NQQBCPI,NQQBBPI,NQCDCPI,
     +              NRPA,NRPB,NRPC,NRPD,NRPE,NRPF,NRPG,NPRT

      DOUBLE PRECISION WMAX
      COMMON /OALPHAS/ WMAX,IMIX

C---GENOUT commmon
#include "h1mcutil/comdef/cgend.inc"

C---cross sections are in picobarn
      NEVT  = NIN
      NGEND = 0
      SIGMT  = SNGL(AVGI) * 1.E3
      DSIGMT = SNGL(SD)*1.E3
      IF(IMIX.NE.1) THEN
         NGEND = NGEND+1
         MSUBPR(NGEND)=IPRO
         SIGMS(NGEND) = SIGMT
         DSIGMS(NGEND) = DSIGMT
      ELSE
         NGEND = NGEND+1
         MSUBPR(NGEND) = 12
         SIGMS(NGEND) = SNGL(AVGI)*FLOAT(NQPM)/FLOAT(NOUT)* 1.E3
         NGEND = NGEND+1
         MSUBPR(NGEND) = 13
         SIGMS(NGEND) = SNGL(AVGI)*FLOAT(NQQB)/FLOAT(NOUT)* 1.E3
         NGEND = NGEND+1
         MSUBPR(NGEND) = 14
         SIGMS(NGEND) = SNGL(AVGI)*FLOAT(NQQBC)/FLOAT(NOUT)* 1.E3
         NGEND = NGEND+1
         MSUBPR(NGEND) = 14
         SIGMS(NGEND) = SNGL(AVGI)*FLOAT(NQQBB)/FLOAT(NOUT)* 1.E3
         NGEND = NGEND+1
         MSUBPR(NGEND) = 15
         SIGMS(NGEND) = SNGL(AVGI)*FLOAT(NQCDC)/FLOAT(NOUT)* 1.E3
         IF(IDISDIF.NE.0) THEN
C non diff x section
            NGEND = NGEND+1
            MSUBPR(NGEND) = 12
            SIGMS(NGEND) = SNGL(AVGI)*FLOAT(NQPMDS)/FLOAT(NOUT)* 1.E3
            NGEND = NGEND+1
            MSUBPR(NGEND) = 13
            SIGMS(NGEND) = SNGL(AVGI)*FLOAT(NQQBDS)/FLOAT(NOUT)* 1.E3
            NGEND = NGEND+1
            MSUBPR(NGEND) = 14
            SIGMS(NGEND) = SNGL(AVGI)*FLOAT(NQQBCDS)/FLOAT(NOUT)* 1.E3
            NGEND = NGEND+1
            MSUBPR(NGEND) = 14
            SIGMS(NGEND) = SNGL(AVGI)*FLOAT(NQQBBDS)/FLOAT(NOUT)* 1.E3
            NGEND = NGEND+1
            MSUBPR(NGEND) = 15
            SIGMS(NGEND) = SNGL(AVGI)*FLOAT(NQCDCDS)/FLOAT(NOUT)* 1.E3
C diff x section
            NGEND = NGEND+1
            MSUBPR(NGEND) = 12
            SIGMS(NGEND) = SNGL(AVGI)*FLOAT(NQPMDF)/FLOAT(NOUT)* 1.E3
            NGEND = NGEND+1
            MSUBPR(NGEND) = 13
            SIGMS(NGEND) = SNGL(AVGI)*FLOAT(NQQBDF)/FLOAT(NOUT)* 1.E3
            NGEND = NGEND+1
            MSUBPR(NGEND) = 14
            SIGMS(NGEND) = SNGL(AVGI)*FLOAT(NQQBCDF)/FLOAT(NOUT)* 1.E3
            NGEND = NGEND+1
            MSUBPR(NGEND) = 14
            SIGMS(NGEND) = SNGL(AVGI)*FLOAT(NQQBBDF)/FLOAT(NOUT)* 1.E3
            NGEND = NGEND+1
            MSUBPR(NGEND) = 15
            SIGMS(NGEND) = SNGL(AVGI)*FLOAT(NQCDCDF)/FLOAT(NOUT)* 1.E3
         ENDIF
         IF(IDISDIF.EQ.2) THEN
C pi x section
            NGEND = NGEND+1
            MSUBPR(NGEND) = 12
            SIGMS(NGEND) = SNGL(AVGI)*FLOAT(NQPMPI)/FLOAT(NOUT)* 1.E3
            NGEND = NGEND+1
            MSUBPR(NGEND) = 13
            SIGMS(NGEND) = SNGL(AVGI)*FLOAT(NQQBPI)/FLOAT(NOUT)* 1.E3
            NGEND = NGEND+1
            MSUBPR(NGEND) = 14
            SIGMS(NGEND) = SNGL(AVGI)*FLOAT(NQQBCPI)/FLOAT(NOUT)* 1.E3
            NGEND = NGEND+1
            MSUBPR(NGEND) = 14
            SIGMS(NGEND) = SNGL(AVGI)*FLOAT(NQQBBPI)/FLOAT(NOUT)* 1.E3
            NGEND = NGEND+1
            MSUBPR(NGEND) = 15
            SIGMS(NGEND) = SNGL(AVGI)*FLOAT(NQCDCPI)/FLOAT(NOUT)* 1.E3
         ENDIF
      ENDIF
      RETURN
      END
