
      SUBROUTINE GRAEVC

*#**********************************************************************
*#
*#    SUBROUTINE GRAEVC
*#
*# PURPOSE: FILLS EVENT CLASSIFICATION DERIVED FROM RAPGAP
*#               INTO THE COMMON /CGEVC/ FOR GENOUT (BANK GEVC)
*#
*# INPUT:   RAPGAP/PYTHIA COMMONS                  
*#
*# OUTPUT:  GENOUT common  /CGEVC/
*#
*# CALLED BY: GENFIL
*#
*# AUTHOR: Michael Colombo          CREATED AT: 91/06/28
*#
*# CHANGED BY: H. JUNG                      AT: 91/08/20
*# REASON: UPDATED FOR RAPGAP
*#
*# CHANGED BY:                              AT:
*# REASON:
*#
*#**********************************************************************



      PARAMETER (NPCMAX =    25,
     +           MAPMAX =     6)
*
      LOGICAL    LALPAR(NPCMAX)
*
#include "rgluco.inc"
#include "rgparas.inc"
#include "rgpart.inc"
#include "rgdiffr.inc"
#include "rglujets.inc"
#include "rgdisdif.inc"
      DOUBLE PRECISION YHS,XHS,Q2HS
      COMMON /HS45/ IHERAC,KPAHS,YHS,XHS,Q2HS
      COMMON /HSOPTN/ INT2(5),INT3(15),ISAM2(5),ISAM3(15),
     +                IOPLOT,IPRINT,ICUT
      Integer Pyk
	External Pyk

C---GENOUT common
*
* NEVTYP    global EVent TYPe
* NINTYP    INnteractionTYPe
* NSPPRC    SPecial PRocess
* NELRAD    RADiation the ELectron side
* NPARSH    PARton SHower
* NQUHUT    QUarks : Heaviest in hard subpr oUTput
* NLEHUT    LEptons: Heaviest in hard subpr oUTput
* NGAHUT    GAuge  : Heaviest in hard subpr oUTput
* NPAHUT    PArtons: all in oUTput
* INBEAM    INcome of the hard subprocess BEAM=electron
* INTARG    INcome of the hard subprocess TARGet=proton
*
*
#include "h1mcutil/comdef/cgevc.inc"
      DO 10 I=1,NPCMAX
         LALPAR( I )  = .FALSE.
   10 CONTINUE
      NEVTYP = 1
      NINTYP = 22
      NSPPRC = 7
      IF(IDIR.EQ.1) NSPPRC = 1
      NLEHUT = 0
      NGAHUT = 0
      NPAHUT = 0
      NQUHUT = 0
      IF(K(NF1,2).NE.21) THEN
         NQUHUT = K(NF1,2)
      ELSEIF(K(NF2,2).NE.21) THEN
         NQUHUT = K(NF2,2)
      ENDIF
      NELRAD = 0
      NPARSH = 0
C     NPARSH   I                ! PARTON SHOWER:
C                               ! BIT PATTERN: 2**(I-1), WHERE
C                               ! I = 1 = INITIAL STATE PARTON SHOWER
C                               ! I = 2 = FINAL   STATE PARTON SHOWER
C                               ! FOR COLOUR DIPOLE MODEL NPARSH = 4
      IF(IHERAC.EQ.1) THEN
C---this generator is truly a radiative one
         IF(ISAM3(1).EQ.1.OR.ISAM3(2).EQ.1.OR.
     +   ISAM3(3).EQ.1.OR.ISAM3(4).EQ.1)
     +   NELRAD    = 3
* NC interaction
         IF ( ISAM2(1) .EQ. 1 .OR. ISAM3(1) .EQ. 1 .OR.
     +        ISAM3(2) .EQ. 1 .OR. ISAM3(3) .EQ. 1 )
     +      NINTYP  = 45
      ENDIF
      IF(IFPS.EQ.1) NPARSH=1
      IF(IFPS.EQ.2) NPARSH=2
      IF(IFPS.EQ.3) NPARSH=3
      IF(IFPS.EQ.10) NPARSH=4
      INBEAM = 22
      IF(IPRO.EQ.18) INBEAM=K(NIA1,2)
      INTARG = K(NIA2,2)
      MSUBPR = IPRO
      IF(IPRO.EQ.15) NGAHUT = 21
* >>> loop over all generated particles
*
      NW = PYK(0,1)
      DO 20  I=1, NW

* flavour code
         IPART = ABS( K(I,2) )
* skip the hadrons and diquarks
         IF ( IPART .GE. 25 )                        GOTO 20
* get the particle status, skip comments
         KS    = K( I, 1 )
         IF ( KS .EQ. 21 )                           GOTO 20
* skip the scatterd electron
         IF ( I .EQ. 3 )                             GOTO 20
* skip the beam particles
         IF ( I .EQ. 1 .OR. I .EQ. 2 )               GOTO 20

* others
         IF ( 1 .LE. IPART .AND. IPART .LE. 25 ) THEN
            IP = IPART
* no photons from decays of leptons (heavier than e) or hadrons
            LALPAR( IP ) = .TRUE.
            IF ( IPART .EQ. 22 ) THEN
               IPP = K( I, 3 )
               IF ( IPP. GT. 0 ) THEN
                  IPARE = K( IPP, 2 )
                  IF ( IPARE .GT. 25 ) LALPAR( IP ) = .FALSE.
                  IF ( 11 .LE. IPARE .AND. IPARE .LE. 16 ) LALPAR( IP)
     +            = .FALSE.
               END IF
            END IF
         END IF
   20 CONTINUE
*
      DO 30  I = 1, NPCMAX
         IF ( LALPAR(I) ) NPAHUT = NPAHUT + 2**I
   30 CONTINUE
      END
