

      SUBROUTINE GRAGKI

*#**********************************************************************
*#
*#    SUBROUTINE GRAGKI
*#
*# PURPOSE: PROVIDE INFORMATION DERIVED FROM RAPGAP 2.03/07 FOR GENOUT
*#          common /CGKI/
*#
*# INPUT: RAPGAP/JETSET COMMONS
*#        and /HEPEVT/
*#
*# OUTPUT: GENOUT common /CGKI/
*#
*# CALLED BY: GENFIL
*#
*# CALLING: ULANGL (from JETSET)
*#
*# AUTHOR: A.Valkarova                     CREATED AT: 91/05/28
*#
*# CHANGED BY: Guenter Grindhammer                 AT: 91/06/07
*# REASON: skip routine for non e-p processes (i.e. real photon beam,
*#         beam-gas, etc.)
*#
*# CHANGED BY: H. JUNG                             AT:94/01/11
*# REASON: UPDATED FOR RAPGAP
*#
*# CHANGED BY: Julian Phillips                     AT:96/09/30
*# REASON: Update for double precision PHEP & VHEP
*#
*# CHANGED BY: Julian Phillips                     AT:96/10/01
*# REASON: Introduce dreadfully inefficient
*#         event weighting in Q2
*#
*#**********************************************************************

C---RAPGAP COMMONS
#include "rgrapgki.inc"
#include "rgeffic.inc"
#include "rgludat1.inc"
#include "rgpypars.inc"
#include "rgstru.inc"
CKEEP, RGPARA1.
      DOUBLE PRECISION Q2,Q2Q,PCM
      COMMON /PARAE/Q2,Q2Q,PCM(4,18)
#include "rgpart.inc"
#include "rgparas.inc"
#include "rgluco.inc"
#include "rgdiffr.inc"
#include "rgdisdif.inc"
      REAL GGPT,GPPT
      COMMON /GRAKT/ GGPT,GPPT
      COMMON/EPPARA/LST(30),IRES(2)
C---JETSET and GENOUT common
#include "hepevt.inc"

C---GENOUT common
#include "h1mcutil/comdef/cgki.inc"


      NGKIN = 5


      IRAD = 0
      GENPL = 0.
      GENPP = 0.
      GENX = -99999.
      GENY = -99999.
      GENQ2 = -99999.
      GENNU = -99999.
      GENW = -99999.
      INLEP=1
      INPRO=2

*   lepton and proton beam momentum at the hard vertex
*   (no radiative photon)
      GENPL = SNGL(PHEP(3,INLEP))
      GENPP = SNGL(PHEP(3,INPRO))
      GENX = SNGL(Q2/SSS)/YY
      GENY = YY
      GENQ2 = SNGL(Q2)
      GENW = SNGL(SQRT(-Q2 + DBLE(YY)*SSS))
      GENNU = YY*SNGL(SSS)/2./0.938
C---label beam and target particles
      ISTHEP(1) = 201
      ISTHEP(2) = 201
C---find the radiative photon (if any)
      IDPH = IABS( IDHEP(5) )
      IF ( IDPH .EQ. 22 ) THEN
         ISTHEP(5) = 202
         IRAD = 1
      END IF


C... MOMENTUM FRACTION ON ELECTRON SIDE
      IF(IRES(1).EQ.0) THEN
         X1 = -99999.
         PDFID1 = -99999
         SCALE1 = -99999.
         XPDF1 = -99999.
      ELSE
         X1 = XEL/YY
         SCALE1 = SCAL2
         XPDF1 = XPD1
         IF(MSTP(56).LT.100) THEN
            PDFID1 = -REAL(MSTP(56))
         ELSE
            PDFID1 = REAL(MSTP(56))
         ENDIF
      ENDIF
C... MOMENTUM FRACTION ON PROTON SIDE

      SCALE2 = SCAL2
      IF(IDIR.EQ.1) THEN
         PDFID2 = MSTP(51)
      ELSEIF(IDIR.EQ.0.AND.(NPOM.EQ.20.OR.NPOM.EQ.21)) THEN
         PDFID2 = MSTP(52)
      ELSE
         PDFID2 = -REAL(NG)
      ENDIF

      XPDF2 = XPD2
      X2 = XPR
      KTI1 = GGPT
      KTI2 = GPPT
c      write(6,*) ' GPT,KTI2',GPT,KTI2
C... Weighting in Q2 with steering card WEQ2
      WTX1 = W_Q2
      WTX2 = 1.0
      SIGMT = SNGL(AVGI) * 1.E3
      DSIGMT = SNGL(SD)*1.E3
      SIGMS = SIGMT
      DSIGMS = DSIGMT
      WTX3 = 1.
C... P_T-HAT**2 OF HARD SUBPROCESS
      PT2HAT = PT2H
C... S-HAT**2 OF HARD SUBPROCESS
      SHAT = SHH
      IF(IPRO.EQ.12) THEN
         PT2HAT = -99999.
         SHAT = -99999.
         XPGKI = -99999.
         ZQGKI = -99999.
         PHITGKI = -99999.
      ENDIF
      IF (NGKIN .GT. 0) THEN
c new...
         GKIN(1) = XPGKI
         GKIN(2) = ZQGKI
         GKIN(3) = PHITGKI
         GKIN(4) = T2GKI
         GKIN(5) = XFGKI
      ENDIF

      RETURN
      END
