
      SUBROUTINE GRAPAR

*#**********************************************************************
*#
*#    SUBROUTINE GRAPAR
*#
*# PURPOSE: COPY UPDATED PARAMETERS FROM RAPGAP 1.04 COMMONS INTO GENOUT
*#          commons. define names of parameter banks.
*#
*# INPUT: RAPGAP COMMONS
*#
*# OUTPUT: GENOUT commons /GPR/, /GPI/, /GPA/, /GPL/, and /GBKNAM/
*#
*# CALLED BY: GENFIL
*#
*# CALLING: UCOPY
*#
*# AUTHOR: Guenter Grindhammer             CREATED AT: 91/05/28
*#
*# CHANGED BY:  H . JUNG                           AT: 91/08/20
*# REASON: UDAPTED FOR RAPGAP
*#
*#**********************************************************************

C---RAPGAP PARAMETER COMMONS---
#include "rgluco.inc"
#include "rgparas.inc"
#include "rgpart.inc"
#include "rgdiffr.inc"
#include "rgpypars.inc"

C---GENOUT PARAMETER COMMONS---
#include "h1mcutil/comdef/cgpar.inc"

C---define parameter bank names and parameter version number for GENOUT.
C   the parameter version number starts out being identical to the
C   author's generator version number (2 or 3 digits) and is not changed
C   when only code has been updated but the meaning of the previously
C   defined parameters and the parameter array sizes stayed the same.
      BKNAMR = 'GRAR'
      BKNAMI = 'GRAI'
      BKNAMA = 'GRAA'
C   version number must be >= 100
      BKVERS = 100
      LIPARM =  9
      INPARM(1) = IPRO
      INPARM(2) = IRUNA
      INPARM(3) = IQ2
C     INPARM(4) =
C     INPARM(5) =
      INPARM(6) = NG
      LRPARM =  11
      REPARM(1) = SNGL(THEMA)
      IPROF = IPRO
      IF(IPRO.GT.1000) IPROF = IPRO/1000
      REPARM(2) = SNGL(PT2CUT(IPROF))
      REPARM(3) = SNGL(T2MAX)
      REPARM(4) = SNGL(XF)
      REPARM(5) = SNGL(ALPHP)
      REPARM(6) = SNGL(RN2)
      REPARM(7) = SNGL(THEMI)
      RETURN
      END
