

      PROGRAM H1GEN

*#**********************************************************************
*#
*#    PROGRAM H1GEN
*#
*# PURPOSE:  Main program for modular steering of event generation.
*#
*# AUTHOR: Guenter Grindhammer     CREATED AT: 91/05/28
*#
*# CALLING: BNAMES,BOS,BREADC,INSTCA,draprnIN,BFSEQR,GJPSII,FSEQW
*#
*#
*# CHANGED BY:                              AT:
*# REASON:
*#
*#**********************************************************************

C JPP - Use H1 macros
#include "h1mcutil/comdef/cbosmdl.inc"
#include "h1util/jobnr/cjobnr.inc"
#include "h1util/jobnr/h1unit.inc"
c#include "h1mcutil/comdef/cbcs.inc"
      INTEGER      NHROW,NHCOL,NHLEN
      PARAMETER   (NHROW = 2, NHCOL = 1, NHLEN=2)
      INTEGER      NBOSIW
      PARAMETER   (NBOSIW=1000000)
      INTEGER      IW(NBOSIW)
      REAL         RW(NBOSIW)
      COMMON /BCS/ IW
      EQUIVALENCE (RW(1),IW(1))
      SAVE   /BCS/
	
#if ( defined(H1_VAX) )
*   add error handler for VAX
      CALL UERRHD
*   open steering file(s) readonly/shared
      CALL OPTXFL
#endif


*
*     initialize BOS
*
      CALL BNAMES(1000)
      CALL BOS(IW,NBOSIW)
*
*     read i/o commands and steering banks
* JPP
* Reserve units 11 and 30 for non-fpack use
** 11 is used for HERACLES output
** 30 is used for structure function input
      CALL FRESER(11)
      CALL FRESER(30)

      CALL FPARMR(5)
      CALL BREADC
*
*     check for input file:
*
      IF(IFRST('BOSINPUT',0).NE.0)THEN
         INBOS='BOSINPUT'
      ELSE IF (IFRST('OLDBOS',0).NE.0)THEN
         INBOS='OLDBOS'
      ELSE
         INBOS=' '
      ENDIF

* --- get next job number
*
      JOBNR = MDB('/JOB')
*
* --- initialize random number generator by ISEED value
* 1) check whether RNIN steering bank exists. If yes, take its first
*    word for ISEED. This can be used for debugging, if the user wants
*    to produce the same sequence once more.
* 2) else if H1 data base is written to (i.e. for official production)
*    then the next JOBNR is taken for ISEED.
* 3) else (i.e. for private production) JOBNR=0. In this case the
*    approximate number of minuts since 06.06.1991 or better that of
*    seconds since 17.09.2003 is used.
*
      irnin = 0
      irnin = NLINK('RNIN',0)
      IF (irnin.GT.0) THEN
         ISEED = IW(irnin+1)
         PRINT*,'H1GEN: ISEED = ',ISEED,' from RNIN bank'
      ELSEIF (JOBNR.GT.4) THEN
         ISEED = JOBNR + 1
         PRINT*,'H1GEN: ISEED = ',ISEED,' from JOBNR'
      ELSE
c        ISEED = MINUTS()
         ISEED = NSECONDS()
         PRINT*,'H1GEN: ISEED = ',ISEED,' from NSECONDS'
      ENDIF
*
      IF (ISEED.LT.0) THEN
         ISEED = -ISEED
         PRINT*,'       ISEED is converted to ',ISEED,' !!!'
      ENDIF
      CALL H1RNIN(ISEED)


      N1=0
	N2=0
	J1SEED = IABS(ISEED)
      CALL RM48IN(J1SEED,N1,N2)
      WRITE(6,'(A,I12)') ' H1RN (RM48) initialized from seed: ',J1SEED
* ---- event processing loop ------------------------------------------
*
   10 CALL FSEQR(INBOS,IRET)

      IF (IRET.LT.0) GOTO 20
      CALL GRAPGA
      CALL FSEQW('BOSOUTPUT')

#if ( defined(H1_H1PHAN) )
      CALL H1PHAN
#endif


      GOTO 10
*
*     perform final book keeping

   20 CONTINUE
*      CALL FPARM('CLOSE ALL')
      IND=MDB('/END')
      STOP
      END
