#include <TROOT.h>
#include <TPad.h>
#include <TMapFile.h>
#include <TH1.h>
#include <TH2.h>
#include <TProfile.h>
#include <TSystem.h>
#include <TCanvas.h>
#include <iostream>
#include <TApplication.h>

#include <jni.h>
#include <stdio.h>
#include <math.h>
#include "ClassTwo.h"
#include<iostream>


using namespace std;


JNIEXPORT jint JNICALL Java_JRunMC_hlookup_ClassTwo_jnipower(JNIEnv *env,
                                                 jclass in_cls,
                                                 jint in_int,
                                                 jstring in_string,
                                                 jfloat in_float,
                                                 jfloatArray myarray)

  {


  jboolean blnIsCopy;

  const char* Hname = env->GetStringUTFChars(in_string, &blnIsCopy);

  float* c_array = env->GetFloatArrayElements (myarray, NULL);
// get size 
  jsize len = env->GetArrayLength(myarray);

  float sum=0.0;
  for (int i=0; i<len; i++) {
    sum += c_array[i];
  }
  cout << "Size=" << (int)len  << endl;


  char * RUNDIR; RUNDIR=getenv("RUNMC");
  char MemoryMappedFile[500];
  strcpy(MemoryMappedFile,RUNDIR);
  strncat(MemoryMappedFile,"/pipes/memfile.map",strlen("/pipes/memfile.map") );
  TMapFile* mfile = 0;
  mfile = TMapFile::Create(MemoryMappedFile);
  
  mfile->Print();
  mfile->ls();


  TH1F     *hpx    = 0;
  hpx    = (TH1F *) mfile->Get(Hname, hpx);
  int ntt=(int)(hpx->GetEntries());

  for (int i=0; i<4; i++) {
     int j = i+1; 
     c_array[i]= hpx->GetBinContent(j);
  }


// copy back the array 
   env->ReleaseFloatArrayElements (myarray, c_array, 0);
   return ntt;
 
}
