// * Copyright (C) 2002-2004 Sergei Chekanov (ANL) chekanov@mail.desy.de 
// * This file is part of the RunMC project
// * 
// * Permission is hereby granted, free of charge, to any person obtaining a copy
// * of this software and associated documentation files (the "Software"), to
// * deal in the Software without restriction, including without limitation the
// * rights to use, copy, modify, merge, publish, distribute, sublicense, and/or
// * sell copies of the Software, and to permit persons to whom the Software is
// * furnished to do so, subject to the following conditions:
// *
// * The above copyright notice and this permission notice shall be included in
// * all copies or substantial portions of the Software.
// * 
// * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
// * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
// * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
// * SERGEI  CHEKANOV BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
// * WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF
// * OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
// * SOFTWARE.
// * 
// * Except as contained in this notice, the name of Sergei Chekanov shall
// * not be used in advertising or otherwise to promote the sale, use or other
// * dealings in this Software without prior written authorization from
// * Sergei Chekanov.
// * 
using namespace std;
#include<TROOT.h>
#include<getevkin.h> 
#include<SetIni.h> // include class containing initializations for M
#include<iostream>

// ----------------------- Fill stable hadrons 
Int_t  getevkin() {

   extern SetIni inival;
   extern getevkincommon getevkin_ ; // To access the external COMMON 

// Q2
   getevkin_.rQ2[1]=inival.Q2min; 
   getevkin_.rQ2[2]=inival.Q2max;

// X 
   getevkin_.rXbj[1]=inival.Xmin;
   getevkin_.rXbj[2]=inival.Xmax;

// Y
   getevkin_.rYbj[1]=inival.Ymin;
   getevkin_.rYbj[2]=inival.Ymax;

// W
   getevkin_.rW[1]=inival.Wmin;
   getevkin_.rW[2]=inival.Wmax;

// energy
   getevkin_.ENER1=inival.Energy1;
   getevkin_.ENER2=inival.Energy2; 

// ID
   getevkin_.PID1=inival.IDparticle1;
   getevkin_.PID2=inival.IDparticle2;

//   cout << getevkin_.PID1 << endl;
//   cout << getevkin_.PID2 << endl; 

// PDF
   getevkin_.PDF1=inival.PDFparticle1;
   getevkin_.PDF2=inival.PDFparticle2;



//   cout << getevkin_.rXbj[1] << " " << getevkin_.rXbj[2] << endl;




   return 0;  

}
