// * This code is licensed under:
// * RunMC License, Version 1.0
// * - for license details see http://runmc.sourceforge.net/License.txt
// *
// * Copyright (c) 2005 by S.Chekanov (chekanov@mail.desy.de).
// * All rights reserved.

#include <TROOT.h>
#include <iostream>
#include <fstream>
#include <sys/stat.h>
#include <string> 

#include <SetIni.h> // include class containing initializations for M
#include <SetHisto.h> // initialization of histograms

#include <stdio.h>
#include <stdlib.h>
using namespace std;


/*
// trim_right() family.
inline std::string trim_right(const std::string & source, const std::string & t = " " ) { 
std::string str = source;
return str.erase ( str.find_last_not_of ( t ) + 1 ) ;
}
// trim_left() family.
inline std::string trim_left ( const std::string & source,const std::string & t = " " ) 
{
std::string str = source;
return str.erase ( 0 , source.find_first_not_of ( t ) ) ;
}
// *trim*() family.
*/






char PROJlog[100];
char PROJerr[100];

// for 1D ---------------------------
Double_t xmin1D[500];
Double_t xmax1D[500];
Int_t    nbin1D[500];
char * NAMESA[500]; // histogram names  
Int_t EventsP; // event histogram 
Int_t SingleP; // 1-particle density 
Int_t DoubleP; // 2-particle density  

// for 2D -----------------------------
Double_t x1min2D[250];
Double_t x2min2D[250];  
Double_t x1max2D[250];
Double_t x2max2D[250];
Int_t  n1bin2D[250];
Int_t  n2bin2D[250];
char * NAMESA1[250]; 
char * NAMESA2[250];
char * NAMESA3[250]; // histogram names
Int_t EventsP1; // event histogram
Int_t SingleP1; // 1-particle density
Int_t DoubleP1; // 2-particle density
Int_t EventsP2; // event histogram
Int_t SingleP2; // 1-particle density
Int_t DoubleP2; // 2-particle density

// strings 
string name1D[500];
string n1name2D[250];
string n2name2D[250];



// specify order at which histograms are shown
Int_t OH[9];


// to decomment input file
//  int decomment( char file_in_name[], char file_out_name[], char comment[] );
extern int decom_inverse( char * file_in_name, char * file_out_name,  char comment[] ); 


// global
  SetIni inival;
  SetHisto inihis;

// set initial values in constructer
SetIni::SetIni() {
      Nevents=100;
      MCtype=1;
      MCprocess=0;
      NTread=0;
      NTname="undefined";
      NTdir="undefined";
      NTlumi=0.0;
      IDparticle1=1;
      IDparticle2=1;
      PDFparticle1=1;
      PDFparticle2=1;
      FStype=1;
      Stop=0;    // interap
      Renice=10; // renice
      Energy1=250.;
      Energy2=250.;
      Q2min=1.;
      Q2max=100.;
      Xmin=0.;
      Xmax=1.0;
      Ymin=0.0;
      Ymax=1.0;
      Wmin=0.0;
      Wmax=100000;
      JetType=1;
      Frame=1;
      JetYcut=0.002;
      JetAngle=1;
      JetRecomb=1;
      JetNfixed=2;
      ETmin=0.;
      ETmax=1000000.0; 
      ETAmax=100.;
      ETAmin=-100.;
      MOutput = "analmc";
      PipeName="notset"; 
      Steering=0;
     };

// set initial values in constructer
SetHisto::SetHisto() {
      HistoN=0; HistoNcurrent=0; HistoNcurrent1D=0; HistoNcurrent2D=0; 
      HistoOptions[0]=1; HistoOptions[1]=1;
      HistoOptions[2]=1; HistoOptions[3]=600; HistoOptions[4]=400; HistoOptions[5]=1; 
      HistoOptions[6]=1; HistoOptions[7]=1;   HistoOptions[8]=1; 
      HistoOptions[9]=1; HistoOptions[10]=0;  HistoOptions[11]=0;
      HistoOptions[12]=0; HistoOptions[13]=0; HistoOptions[14]=0;
      HistoOptions[15]=0; HistoOptions[16]=0; HistoOptions[17]=0;
      HistoOptions[18]=0; HistoOptions[19]=0; 
      for (Int_t i=0; i<=500; i++) {
       HistoType[i]=0; Histo2D[i]=1; HistoMax[i]=0.; HistoMin[i]=0.; HistoBins[i]=0;
       HistoWeight[i]=1.;  HistoName[i]="undefined";
      };
      };



// read file 
Int_t initiate() {


// set to zero
   inival.Nevents=0;
   inihis.HistoNcurrent=0; 
   inihis.HistoNcurrent1D=0; 
   inihis.HistoNcurrent2D=0;
   for (Int_t i=0; i<=500; i++) {
    inihis.HistoType[i]=0; inihis.Histo2D[i]=1; inihis.HistoMax[i]=0.; 
    inihis.HistoMin[i]=0.; inihis.HistoBins[i]=0;
    inihis.HistoWeight[i]=1.;  inihis.HistoName[i]="";
    };


   char * ReadINT="integerx.tmp";
   char * ReadREA="realx.tmp";
   char * ReadSTR="stringx.tmp";
   char * ReadHISTO="histox.tmp";
   char * ReadOPTIONS="optionsx.tmp";

// decomment card file
   int iicheck=0;
   iicheck=decom_inverse(".runmc.in",ReadINT,"I");
   if (iicheck !=  0 ){ cout << "Cannot find file " << ReadINT << endl; return 1; }
   iicheck=decom_inverse(".runmc.in",ReadREA,"R");
   if (iicheck !=  0 ){ cout << "Cannot find file " << ReadREA << endl; return 1; }
   iicheck=decom_inverse(".runmc.in",ReadSTR,"S");
   if (iicheck !=  0 ){ cout << "Cannot find file " << ReadSTR << endl; return 1; }
   iicheck=decom_inverse(".runmc.in",ReadHISTO,"H");
   if (iicheck !=  0 ){ cout << "Cannot find file " << ReadHISTO << endl; return 1; }
   iicheck=decom_inverse(".runmc.in",ReadOPTIONS,"O");
   if (iicheck !=  0 ){ cout << "Cannot find file " << ReadOPTIONS << endl; return 1; }



// read files
   char   buff[60];
   float  VRea;
   char   VSOpt[20];

// loop over all real
   int nreal=0; char * tmp;
   FILE *ls2 = fopen(ReadREA,"r");
   if (ls2  == NULL ){ cout << "Cannot find " <<  ReadREA << endl; return 1; }
   while ( !feof(ls2) ) {
     fscanf(ls2,"%s %f \n", buff, &VRea);
     tmp = new char[strlen(buff)+1]; strcpy(tmp,buff);
     if (strcmp(tmp,"R-ENERGY1") == 0 )  inival.Energy1=VRea;
     if (strcmp(tmp,"R-ENERGY2") == 0 )  inival.Energy2=VRea;
     if (strcmp(tmp,"R-YCUT") == 0 )     inival.JetYcut=VRea;
     if (strcmp(tmp,"R-Q2MIN") == 0 )    inival.Q2min=VRea;
     if (strcmp(tmp,"R-Q2MAX") == 0 )    inival.Q2max=VRea;
     if (strcmp(tmp,"R-XMIN") == 0 )     inival.Xmin=VRea;
     if (strcmp(tmp,"R-XMAX") == 0 )     inival.Xmax=VRea;
     if (strcmp(tmp,"R-YMIN") == 0 )     inival.Ymin=VRea;
     if (strcmp(tmp,"R-YMAX") == 0 )     inival.Ymax=VRea;
     if (strcmp(tmp,"R-WMIN") == 0 )     inival.Wmin=VRea;
     if (strcmp(tmp,"R-WMAX") == 0 )     inival.Wmax=VRea;
     if (strcmp(tmp,"R-ETMIN") == 0 )    inival.ETmin=VRea;
     if (strcmp(tmp,"R-ETMAX") == 0 )    inival.ETmax=VRea;
     if (strcmp(tmp,"R-ETAMIN") == 0 )   inival.ETAmin=VRea;
     if (strcmp(tmp,"R-ETAMAX") == 0 )   inival.ETAmax=VRea;
     if (strcmp(tmp,"R-NTlumi") == 0 )   inival.NTlumi=VRea;
//     cout << tmp << " " << VRea << endl;
     nreal++;
   }
   fclose(ls2);



// loop over all integer
   int   VInt;
   int inter=0;
   FILE *ls3 = fopen(ReadINT,"r");
   if (ls3  == NULL ){ cout << "Cannot find " <<  ReadINT << endl; return 1; }
   while ( !feof(ls3) ) {
     fscanf(ls3,"%s %d \n", buff, &VInt);
     tmp = new char[strlen(buff)+1]; strcpy(tmp,buff);
     if (strcmp(tmp,"I-EVENTS") == 0 )  inival.Nevents=VInt;
     if (strcmp(tmp,"I-MCTYPE") == 0 )  inival.MCtype=VInt;
     if (strcmp(tmp,"I-PROCESS") == 0 ) inival.MCprocess=VInt;
     if (strcmp(tmp,"I-ID1") == 0 )     inival.IDparticle1=VInt;
     if (strcmp(tmp,"I-ID2") == 0 )     inival.IDparticle2=VInt;
     if (strcmp(tmp,"I-PDF1") == 0 )    inival.PDFparticle1=VInt;
     if (strcmp(tmp,"I-PDF2") == 0 )    inival.PDFparticle2=VInt;
     if (strcmp(tmp,"I-NTTYPE") == 0 )  inival.NTwhat=VInt;
     if (strcmp(tmp,"I-NTREAD") == 0 )  inival.NTread=VInt;
     if (strcmp(tmp,"I-FSTYPE") == 0 )  inival.FStype=VInt;
     if (strcmp(tmp,"I-JETTYPE") == 0 ) inival.JetType=VInt;
     if (strcmp(tmp,"I-NJETS") == 0 )   inival.JetNfixed=VInt;
     if (strcmp(tmp,"I-ANGLE") == 0 )   inival.JetAngle=VInt;
     if (strcmp(tmp,"I-RECOMB") == 0 )  inival.JetRecomb=VInt;
     if (strcmp(tmp,"I-STOP") == 0 )    inival.Stop=VInt;
     if (strcmp(tmp,"I-RENICE") == 0 )  inival.Renice=VInt;
     if (strcmp(tmp,"I-STEER") == 0 )   inival.Steering=VInt;
//   cout << tmp  << " " << VInt << endl;
     inter++;
   }
   fclose(ls3);


// loop over all strings
   int nstring=0;
   char VCha[300];
   FILE *ls4 = fopen(ReadSTR,"r");
   if (ls4  == NULL ){ cout << "Cannot find " <<  ReadSTR << endl; return 1; }
   while ( !feof(ls4) ) {
     fscanf(ls4,"%s %s \n", buff, VCha);
// next strings
     tmp = new char[strlen(buff)+1]; strcpy(tmp,buff);
     if (strcmp(tmp,"S-PROJECT") == 0 ) {inival.MOutput = new char[strlen(VCha)+1]; strcpy(inival.MOutput,VCha);};
     if (strcmp(tmp,"S-NTNAME") == 0 ) {inival.NTname = new char[strlen(VCha)+1]; strcpy(inival.NTname,VCha);};
     if (strcmp(tmp,"S-NTDIR") == 0 ) {inival.NTdir = new char[strlen(VCha)+1]; strcpy(inival.NTdir,VCha);};
     if (strcmp(tmp,"S-PIPE") == 0 ) {inival.PipeName = new char[strlen(VCha)+1]; strcpy(inival.PipeName,VCha);};
//   cout << tmp << " " << VCha << endl;
     nstring++;
   }
   fclose(ls4);

 
 
// read option files
   FILE *ls5 = fopen(ReadOPTIONS,"r");
   if (ls5  == NULL ){ cout << "Cannot find " <<  ReadOPTIONS  << endl; return 1; }
   fscanf(ls5,"%s", VSOpt);
   fscanf(ls5,"%d %d %d", &inihis.HistoOptions[0],&inihis.HistoOptions[1],&inihis.HistoOptions[2]);
   fscanf(ls5,"%d %d %d", &inihis.HistoOptions[3],&inihis.HistoOptions[4],&inihis.HistoOptions[5]); //canvas
   fscanf(ls5,"%d %d %d", &inihis.HistoOptions[6],&inihis.HistoOptions[7],&inihis.HistoOptions[8]);
   fscanf(ls5,"%d %d %d", &inihis.HistoOptions[9],&inihis.HistoOptions[10],&inihis.HistoOptions[11]);
   fscanf(ls5,"%d %d %d", &inihis.HistoOptions[12],&inihis.HistoOptions[13],&inihis.HistoOptions[14]); // not used
   fscanf(ls5,"%d %d %d", &inihis.HistoOptions[15],&inihis.HistoOptions[16],&inihis.HistoOptions[17]);
   fscanf(ls5,"%d %d %d \n", &inihis.HistoOptions[18],&inihis.HistoOptions[19]);
   fclose(ls5);


// now get histograms
    int nk1=0;
    int nk2=0;
    char bb[201];
    string TitleH[500];
    struct stat buf;
    int isi = stat (ReadHISTO,&buf);
    int file_size=0; file_size=buf.st_size;
 
     if (file_size >2 && isi == 0 ) {
     FILE *ls6 = fopen(ReadHISTO,"r");
     while ( !feof(ls6) ) {  

     fgets(bb,200,ls6);
     string  sline=bb;
     string::size_type pos = sline.find (" ",0); 
     string  shead  =  sline.substr(0,pos);
     string  srest =  sline.substr(pos+1,sline.length());
// trimn from left and righth 
     for (unsigned n=0; n<srest.length();n++) srest.erase(0,srest.find_first_not_of (" "));
     for (unsigned n=0; n<srest.length();n++) srest.erase (srest.find_last_not_of(" ")+1);

     if (shead == "H-NAME") {
       nk1++; 
       if (nk1>500) {
       cout << "Too many histograms (more than 500). Not supported" << endl;
       return 1;}

       pos = srest.find(" ",0);
       string  stitle   =  srest.substr(0,pos);
       string  scomment =  srest.substr(pos,srest.length());
       for (unsigned n=0; n<stitle.length();n++) stitle.erase(0,stitle.find_first_not_of (" "));
       for (unsigned n=0; n<stitle.length();n++) stitle.erase(stitle.find_last_not_of(" ")+1);
       TitleH[nk1]=stitle;
 //      cout << stitle << endl;
     }


    if (shead == "H-INFO") {
      nk2++; 

        if (nk2>500) {
        cout << "Too many histograms (more than 500). Not supported" << endl;
        return 1;}

      for (unsigned n=0; n<srest.length();n++) srest.erase(0,srest.find_first_not_of (" ")); 
      pos = srest.find(" ",0);
      string  s1   =  srest.substr(0,pos);
      string  srest1 =  srest.substr(pos+1,srest.length());
      for (unsigned n=0; n<srest1.length();n++) srest1.erase(0,srest1.find_first_not_of (" ")); 

      pos = srest1.find(" ",0);
      string  s2   =  srest1.substr(0,pos);
      string  srest2 =  srest1.substr(pos+1,srest1.length());
      for (unsigned n=0; n<srest2.length();n++) srest2.erase(0,srest2.find_first_not_of (" "));

      pos = srest2.find(" ",0);
      string  s3   =  srest2.substr(0,pos);
      string  srest3 =  srest2.substr(pos+1,srest2.length());
      for (unsigned n=0; n<srest3.length();n++) srest3.erase(0,srest3.find_first_not_of (" "));

      pos = srest3.find(" ",0);
      string  s4   =  srest3.substr(0,pos);
      string  srest4 =  srest3.substr(pos+1,srest3.length());
      for (unsigned n=0; n<srest4.length();n++) srest4.erase(0,srest4.find_first_not_of (" "));


      pos = srest4.find(" ",0);
      string  s5   =  srest4.substr(0,pos);
      string  srest5 =  srest4.substr(pos+1,srest4.length());
      for (unsigned n=0; n<srest5.length();n++) srest5.erase(0,srest5.find_first_not_of (" "));
 
//     cout <<  srest2 << endl;
       inihis.Histo2D[nk2]=atoi(s1.c_str()); 
       inihis.HistoMin[nk2]=atof(s2.c_str());
       inihis.HistoMax[nk2]=atof(s3.c_str());
       inihis.HistoBins[nk2]=atoi(s4.c_str()); 
       inihis.HistoWeight[nk2]=atof(s5.c_str()); 
//       cout << inihis.Histo2D[nk2] << " " << inihis.HistoMin[nk2] << " " << inihis.HistoMax[nk2] << endl; 
     } 

     }; // end while 
     fclose(ls6);
     };

// remove temporary file
    remove (ReadINT);
    remove (ReadREA);
    remove (ReadSTR);
    remove (ReadHISTO);
    remove (ReadOPTIONS);

    if (nk1 != nk2-1 && (nk1>0 || nk2>0) ) {
    cout << "Error in the defininition of histogrms "<< endl; 
    cout << "H-INFO does not match to H-NNAME" << endl; 
    return 1;}    

    if (nk1 == 0 ||  nk2 == 0)  {
    cout << "Error in the defininition of histogrms! "<< endl;
    cout << "It seems you did not specify any histogram\n" << endl;
    return 2;}



    inihis.HistoN=nk1;
    inihis.HistoNcurrent=nk1;
//    cout << "read = " <<  inihis.HistoNcurrent << endl;
// get names
    strncat(PROJlog, "", 99);              
    strncat(PROJerr, "", 99);
    strncat(PROJlog,inival.MOutput, strlen(inival.MOutput));
    strncat(PROJerr,inival.MOutput, strlen(inival.MOutput));
    strncat(PROJlog,".log", 4);
    strncat(PROJerr,".err", 4);
    cout << "RUNMC: Log    file is " << PROJlog << endl;
    cout << "RUNMC: Error  file is " << PROJerr << endl;
 
// 1D histograms
    inihis.HistoNcurrent1D=0;
    inihis.HistoNcurrent2D=0;
    Int_t define2D[250];


    for  (Int_t i=1; i<=inihis.HistoN; i++ ) {
    if (inihis.Histo2D[i] == 1) { 
      inihis.HistoNcurrent1D++; 
      xmin1D[inihis.HistoNcurrent1D]=inihis.HistoMin[i];
      xmax1D[inihis.HistoNcurrent1D]=inihis.HistoMax[i];
      nbin1D[inihis.HistoNcurrent1D]=inihis.HistoBins[i];
      name1D[inihis.HistoNcurrent1D] = TitleH[i];
 
//        cout << "-" << name1D[inihis.HistoNcurrent1D] << "-" << endl;
//      cout << "+" << ss << "+" << endl; 
// 2D histograms
    } else if (inihis.Histo2D[i] == 2) {     
      inihis.HistoNcurrent2D++;
      define2D[inihis.HistoNcurrent2D]=i;
     } else {
       ofstream myout(PROJerr, ios::out | ios::app);
       myout << "Error in the definition of histogram\n"; 
       myout << "Histogram should have 1 or 2 to define 1D or 2D type\n";
       myout.close();

       ofstream myout1(PROJlog, ios::out | ios::app);
       myout1 << "Error in the definition of histogram\n";
       myout1 << "Histogram should have 1 or 2 to define 1D or 2D type\n";
       myout1.close();
       return 1;
    }; };


// check 
    if (  (inihis.HistoNcurrent2D%2) != 0) {
       ofstream myout(PROJerr, ios::out | ios::app);
       myout << "Error in the definition of 2D histograms \n";
       myout << "You should specify even number of histograms to make 2D histograms\n";
       myout.close();

       ofstream myout1(PROJlog, ios::out | ios::app);
       myout1 << "Error in the definition of 2D histograms \n";
       myout1 << "You should specify even number of histograms to make 2D histograms\n";
       myout1.close();
       return 1;
       };


// get order at which histograms are shown
      for  (Int_t i=1; i<=8; i++ ) OH[i]=1; // by default assume all 1D histogarms 
// 1st histo 
      if (inihis.Histo2D[1] == 2) OH[1]=2;
// 2nd histo
      if (OH[1] == 1 && inihis.Histo2D[2] == 2) OH[2]=2; 
      if (OH[1] == 2 && inihis.Histo2D[3] == 2) OH[2]=2;
// 3rd histo
      if (OH[1]*OH[2] == 1 && inihis.Histo2D[3] == 2) OH[3]=2; 
      if (OH[1]*OH[2] == 2 && inihis.Histo2D[4] == 2) OH[3]=2;
      if (OH[1]*OH[2] == 4 && inihis.Histo2D[5] == 2) OH[3]=2;
//4th
      Int_t m1=1;
      for  (Int_t i=1; i<=4; i++ ) { 
      m1=m1*2;
      if (i == 1) m1=1; 
      if (OH[1]*OH[2]*OH[3] == m1 && inihis.Histo2D[3+i] == 2) OH[4]=2; } 
// 5 histogram
      m1=1;
      for  (Int_t i=1; i<=5; i++ ) { 
      m1=m1*2;
      if (i == 1) m1=1;
      if (OH[1]*OH[2]*OH[3]*OH[4] == m1 && inihis.Histo2D[4+i] == 2) OH[5]=2; };
// 6 histogram
      m1=1;
      for  (Int_t i=1; i<=6; i++ ) {
      m1=m1*2;
      if (i == 1) m1=1;
      if (OH[1]*OH[2]*OH[3]*OH[4]*OH[5] == m1 && inihis.Histo2D[5+i] == 2) OH[6]=2; };
// 7 histogram
      m1=1;
      for  (Int_t i=1; i<=7; i++ ) { 
      m1=m1*2;
      if (i == 1) m1=1;
      if (OH[1]*OH[2]*OH[3]*OH[4]*OH[5]*OH[6] == m1 && inihis.Histo2D[6+i] == 2) OH[7]=2; };
// 8 histogram
      m1=1;
      for  (Int_t i=1; i<=8; i++ ) { 
      m1=m1*2;
      if (i == 1) m1=1;
      if (OH[1]*OH[2]*OH[3]*OH[4]*OH[5]*OH[6]*OH[7] == m1 && inihis.Histo2D[7+i] == 2) OH[8]=2; };
 

// get names for 1 D histograms
  string nameTMP,nameTMP1,nameTMP2,NEWP1,NEWP2;
  string a("@");  
  EventsP=0;
  SingleP=0;
  DoubleP=0;
// move all stuff to the strings
   for  (Int_t i=1; i<=inihis.HistoNcurrent1D; i++ ) {
   string s1 = name1D[i].substr(0,1);
   string s2 = name1D[i].substr(1,1);
   string Sname1D=name1D[i];
   if ( a == s1 && a != s2) Sname1D.erase(0,1);
   if ( a == s1 && a == s2) Sname1D.erase(0,2);
   const char *tmps=Sname1D.c_str();
   NAMESA[i] = new char[strlen(tmps)];
   strcpy(NAMESA[i],tmps);
 
//   cout << "+" << NAMESA[i] << "+" << endl;
// for events
   if ( a != s1) EventsP++; 
// for single-particle density
   if ( a == s1 && a != s2) SingleP++; 
// for 2-particle density
   if ( a == s1 && a == s2) DoubleP++; 
   }



// -------------- 2D histograms 
// calculate number of 2D histograms
  inihis.HistoNcurrent2D= inihis.HistoNcurrent2D / 2; 


  EventsP1=0;
  SingleP1=0;
  DoubleP1=0;
  EventsP2=0;
  SingleP2=0;
  DoubleP2=0;


      Int_t j1=1; Int_t j2=2; 
// define 2D histograms 
      for  (Int_t i=1; i<=inihis.HistoNcurrent2D; i++ ) {
      if (i > 1 ) j1=j1+2;
      if (i > 1 ) j2=j2+2;
      x1min2D[i]=inihis.HistoMin[define2D[j1]];
      x1max2D[i]=inihis.HistoMax[define2D[j1]];
      n1bin2D[i]=inihis.HistoBins[define2D[j1]];
      x2min2D[i]=inihis.HistoMin[define2D[j2]];
      x2max2D[i]=inihis.HistoMax[define2D[j2]];
      n2bin2D[i]=inihis.HistoBins[define2D[j2]];
      n1name2D[i] = TitleH[define2D[j1]];
      n2name2D[i] = TitleH[define2D[j2]];
//


// get all names without "@"

      string nf1=n1name2D[i].substr(0,1); 
      string nf2=n1name2D[i].substr(1,1);
      string Sn1name2D=n1name2D[i];
      if ( a == nf1 && a != nf2) Sn1name2D.erase(0,1);
      if ( a == nf1 && a == nf2) Sn1name2D.erase(0,2);
      if ( a != nf1 && a != nf2) EventsP1++;
      if ( a == nf1 && a != nf2) SingleP1++;
      if ( a == nf1 && a == nf2) DoubleP1++;
      const char *tmps1=Sn1name2D.c_str();
      NAMESA1[i] = new char[strlen(tmps1)];
      strcpy(NAMESA1[i],tmps1);



// second variable
      nf1=n2name2D[i].substr(0,1);
      nf2=n2name2D[i].substr(1,1);
      string Sn2name2D=n2name2D[i];
      if ( a == nf1 && a != nf2) Sn2name2D.erase(0,1);
      if ( a == nf1 && a == nf2) Sn2name2D.erase(0,2);
      if ( a != nf1 && a != nf2) EventsP2++;
      if ( a == nf1 && a != nf2) SingleP2++;
      if ( a == nf1 && a == nf2) DoubleP2++;
      const char *tmps2=Sn2name2D.c_str();
      NAMESA2[i] = new char[strlen(tmps2)];
      strcpy(NAMESA2[i],tmps2);

// get full name
      string fullname=Sn1name2D+"-"+Sn2name2D; 
      const char *tmps3=fullname.c_str();
      NAMESA3[i] = new char[strlen(tmps3)];
      strcpy(NAMESA3[i],tmps3);

     }



// define total number of histograms
      inihis.HistoNcurrent=inihis.HistoNcurrent1D+inihis.HistoNcurrent2D;



   return 0;
   }

