/* This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/



//RunJava - this class runs the java interpreter by passing arguments to the process class.
//(C)2000-2001 Mark Beynon
//mark@jpedit.co.uk
//http://www.jpedit.co.uk

package com.javac;

//import java.awt.*;
import javax.swing.JTextArea;

import java.io.File;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.BufferedReader;

import com.jpe.jpe;
import com.utils.*;




public class RunJava implements Runnable
{

	public RunJava(jpe win, String Options, String jdk)
	{
		super();
		this.win     = win;
		this.Options = Options;
		this.jdk     = jdk;

  }

	public void run()
	{
		run(Options, jdk);
	}

	private void killThread()
	{
		win.stopJavaThread();
		//this.destroy();
	}

	public void run(String Options, String jdk)
	{

		String line = new String();
	  InputStreamReader inp;
		BufferedReader bufred;
		String gap = " ";
		JTextArea jtacomp = new JTextArea();
		Process ps = null;


		if(jdk == null)
		{
			Utils.userMessage("Warning", "Please specify JDK path", 1);
			win.setJavaHome();
			jdk = win.getJDK();
			//return;
		}

		if(Options == null)
		{
			Utils.userMessage("Warning", "Please specify Interpreter Options", 1);
			win.JavacOptions();
			Options = win.getRunOptions();
			//return;
		}

		if ((jdk != null) && (Options != null))
		{

			try
			{
				ps = Runtime.getRuntime().exec(jdk + fileSep + Options);

	      inp = new InputStreamReader(ps.getErrorStream());
				bufred = new BufferedReader(inp);

				while((line=bufred.readLine())!=null)
				{
					jtacomp.append(line + "\n");
				}
					inp.close();
				  bufred.close();
			}
			catch (Exception err)
			{
	    	System.out.println("error running interpreter" + err.getMessage ());
	    	Utils.userMessage("Error", "An error has occured, please see error log.", 1);
	    	Utils.writeErrorLog("error running interpreter" + err.getMessage());
	    }
	    finally
	    {
	      ps = null;
	      inp = null;
		    bufred = null;
	    }

			win.clearConsole();
			win.setConsole(jdk + fileSep + Options +"\n" + jtacomp.getText() + "Operation complete");

	  }
	  else
	  {
	  	win.clearConsole();
			win.setConsole("Invalid JDK and or java options specified");
	  }

     killThread();

  }


	private jpe win;
	private Utils Utils = new Utils(win);
	private String fileSep = System.getProperty("file.separator");
	private boolean javacerror = false;
	private Thread thread;
	private String Options;
	private String jdk;




}




